; ##############################################################################
; ##############################################################################
; ##############################################################################
; VERSION: 11/2015																
;																				
; Diese Routine stellt ein ASCII-Zeichen auf dem Display dar.					
; INP: temp	(0...127 ASCII, 128...255 inverses ASCII							
;																				
; REGISTER: R0, R1 (werden nicht gesichert)										
;																				
ASCII_TEMP:
	push temp
	push temp8
	push temp9
	push XL
	push XH
	push ZL
	push ZH
;-------------------------------------------------------------------------------
	; ASCII invers ?				
	clr temp8
	SBRC temp,7					
	mov temp8,EINS
;-------------------------------------------------------------------------------
	; FONT-TABELLE Z initialisieren			
	ldi ZH, high(FONT*2)
	ldi ZL,  low(FONT*2)
	ldi temp9,48
	andi temp,0b01111111	; 0...127
	MUL temp,temp9
	add ZL,R0
	adc ZH,R1
;-------------------------------------------------------------------------------
	; CURSOR laden X (ZEILE)				
	LDS XL,(adr_GRAFIC_CURSOR_L)
	LDS XH,(adr_GRAFIC_CURSOR_H)
	; BERLAUF ?							
	cpi XH, HIGH(adr_TV_BILDBEREICH_ENDE+1)
	brlo ASCII_TEMP_RUN
	breq ASCII_TEMP_LOW
	rjmp ASCII_TEMP_ERROR
ASCII_TEMP_LOW:
	cpi XL, LOW(adr_TV_BILDBEREICH_ENDE+1)
	brlo ASCII_TEMP_RUN
	breq ASCII_TEMP_RUN
	rjmp ASCII_TEMP_ERROR
ASCII_TEMP_ERROR:
	; ERROR									
	STS(adr_GRAFIC_CURSOR_SPALTE),NULL
	ldi XL, LOW (adr_TV_BILDBEREICH-45+45*24*1)
	ldi XH, HIGH(adr_TV_BILDBEREICH-45+45*24*1)
	STS(adr_GRAFIC_CURSOR_L),XL
	STS(adr_GRAFIC_CURSOR_H),XH
;-------------------------------------------------------------------------------
; ASCII aus TABELLE holen				
ASCII_TEMP_RUN:
	ldi temp9,24					; SCHLEIFE			
ASCII_TEMP_s1:
	LPM temp, Z+   					; aus Tabelle laden	
	; BITTAUSCH			
	MOV R0,temp
	clr temp
	SBRC R0,0
	ori temp,0b10000000
	SBRC R0,1
	ori temp,0b01000000
	SBRC R0,2
	ori temp,0b00100000
	SBRC R0,3
	ori temp,0b00010000
	SBRC R0,4
	ori temp,0b00001000
	SBRC R0,5
	ori temp,0b00000100
	SBRC R0,6
	ori temp,0b00000010
	SBRC R0,7
	ori temp,0b00000001
	push temp						; sichern			
	LPM temp, Z+   					; aus Tabelle laden	
	; BITTAUSCH			
	MOV R0,temp			
	clr temp
	SBRC R0,0
	ori temp,0b10000000
	SBRC R0,1
	ori temp,0b01000000
	SBRC R0,2
	ori temp,0b00100000
	SBRC R0,3
	ori temp,0b00010000
	SBRC R0,4
	ori temp,0b00001000
	SBRC R0,5
	ori temp,0b00000100
	SBRC R0,6
	ori temp,0b00000010
	SBRC R0,7
	ori temp,0b00000001
	push temp						; sichern			
	dec temp9						; SCHLEIFE			
	brne ASCII_TEMP_s1
;-------------------------------------------------------------------------------
; ASCII write (von unten nach oben)		
	ldi temp9,24					; SCHLEIFE			
ASCII_TEMP_s2:
	pop temp						; wiederherstellen (HIGH)		
	SBRC temp8,0					; ASCII invers ?				
	com temp						; invertieren					
	ST X+,temp						; in BILDSPEICHER speichern	X+1	
	pop temp						; wiederherstellen (LOW)		
	SBRC temp8,0					; ASCII invers ?				
	com temp						; invertieren					
	ST X+,temp						; in BILDSPEICHER speichern	X+1	
	SBIW XL,47						; SRAM-ADRESSE auf nchste ZEILE
	dec temp9						; SCHLEIFE			
	brne ASCII_TEMP_s2
;-------------------------------------------------------------------------------
	; CURSOR SPALTE							
	LDS XL,(adr_GRAFIC_CURSOR_L)
	LDS XH,(adr_GRAFIC_CURSOR_H)
	; CURSOR-SPALTENZHLER					
	LDS temp,(adr_GRAFIC_CURSOR_SPALTE)
	inc temp
	STS(adr_GRAFIC_CURSOR_SPALTE),temp
	cpi temp,22
	brsh ASCII_TEMP_NEW_ZEILE
	adiw XL,2
	rjmp ASCII_TEMP_FERTIG
;-------------------------------------------------------------------------------
ASCII_TEMP_NEW_ZEILE:
	; CURSOR auf neue ZEILE					
	STS(adr_GRAFIC_CURSOR_SPALTE),NULL
	subi XL,LOW (-1038)
	sbci XH,HIGH(-1038)
;-------------------------------------------------------------------------------
ASCII_TEMP_FERTIG:
	; CURSOR save X (ZEILE)				
	STS(adr_GRAFIC_CURSOR_L),XL
	STS(adr_GRAFIC_CURSOR_H),XH
	pop ZH
	pop ZL
	pop XH
	pop XL
	pop temp9
	pop temp8
	pop temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ASCII_TEXT_Z:
	LPM temp, Z+   			; aus Tabelle laden und Zeiger um 1 erhhen	
	tst temp  			
	brne ASCII_TEXT_w
	ret
ASCII_TEXT_w:
	rcall ASCII_TEMP			; Anzeige
	rjmp ASCII_TEXT_Z
; ##############################################################################
; ##############################################################################
; ##############################################################################
ASCII_CURSOR_ZEILE_1:
	push XL
	push XH
	STS(adr_GRAFIC_CURSOR_SPALTE),NULL
	ldi XL, LOW (adr_TV_BILDBEREICH-45+45*24*1)
	ldi XH, HIGH(adr_TV_BILDBEREICH-45+45*24*1)
	STS(adr_GRAFIC_CURSOR_L),XL
	STS(adr_GRAFIC_CURSOR_H),XH
	pop XH
	pop XL
ret
;-------------------------------------------------------------------------------
ASCII_CURSOR_ZEILE_2:
	push XL
	push XH
	STS(adr_GRAFIC_CURSOR_SPALTE),NULL
	ldi XL, LOW (adr_TV_BILDBEREICH-45+45*24*2)
	ldi XH, HIGH(adr_TV_BILDBEREICH-45+45*24*2)
	STS(adr_GRAFIC_CURSOR_L),XL
	STS(adr_GRAFIC_CURSOR_H),XH
	pop XH
	pop XL
ret
;-------------------------------------------------------------------------------
ASCII_CURSOR_ZEILE_3:
	push XL
	push XH
	STS(adr_GRAFIC_CURSOR_SPALTE),NULL
	ldi XL, LOW (adr_TV_BILDBEREICH-45+45*24*3)
	ldi XH, HIGH(adr_TV_BILDBEREICH-45+45*24*3)
	STS(adr_GRAFIC_CURSOR_L),XL
	STS(adr_GRAFIC_CURSOR_H),XH
	pop XH
	pop XL
ret
;-------------------------------------------------------------------------------
ASCII_CURSOR_ZEILE_4:
	push XL
	push XH
	STS(adr_GRAFIC_CURSOR_SPALTE),NULL
	ldi XL, LOW (adr_TV_BILDBEREICH-45+45*24*4)
	ldi XH, HIGH(adr_TV_BILDBEREICH-45+45*24*4)
	STS(adr_GRAFIC_CURSOR_L),XL
	STS(adr_GRAFIC_CURSOR_H),XH
	pop XH
	pop XL
ret
;-------------------------------------------------------------------------------
ASCII_CURSOR_ZEILE_5:
	push XL
	push XH
	STS(adr_GRAFIC_CURSOR_SPALTE),NULL
	ldi XL, LOW (adr_TV_BILDBEREICH-45+45*24*5)
	ldi XH, HIGH(adr_TV_BILDBEREICH-45+45*24*5)
	STS(adr_GRAFIC_CURSOR_L),XL
	STS(adr_GRAFIC_CURSOR_H),XH
	pop XH
	pop XL
ret
;-------------------------------------------------------------------------------
ASCII_CURSOR_ZEILE_6:
	push XL
	push XH
	STS(adr_GRAFIC_CURSOR_SPALTE),NULL
	ldi XL, LOW (adr_TV_BILDBEREICH-45+45*24*6)
	ldi XH, HIGH(adr_TV_BILDBEREICH-45+45*24*6)
	STS(adr_GRAFIC_CURSOR_L),XL
	STS(adr_GRAFIC_CURSOR_H),XH
	pop XH
	pop XL
ret
;-------------------------------------------------------------------------------
ASCII_CURSOR_ZEILE_7:
	push XL
	push XH
	STS(adr_GRAFIC_CURSOR_SPALTE),NULL
	ldi XL, LOW (adr_TV_BILDBEREICH-45+45*24*7)
	ldi XH, HIGH(adr_TV_BILDBEREICH-45+45*24*7)
	STS(adr_GRAFIC_CURSOR_L),XL
	STS(adr_GRAFIC_CURSOR_H),XH
	pop XH
	pop XL
ret
;-------------------------------------------------------------------------------
ASCII_CURSOR_ZEILE_8:
	push XL
	push XH
	STS(adr_GRAFIC_CURSOR_SPALTE),NULL
	ldi XL, LOW (adr_TV_BILDBEREICH-45+45*24*8)
	ldi XH, HIGH(adr_TV_BILDBEREICH-45+45*24*8)
	STS(adr_GRAFIC_CURSOR_L),XL
	STS(adr_GRAFIC_CURSOR_H),XH
	pop XH
	pop XL
ret
;-------------------------------------------------------------------------------
ASCII_CURSOR_ZEILE_9:
	push XL
	push XH
	STS(adr_GRAFIC_CURSOR_SPALTE),NULL
	ldi XL, LOW (adr_TV_BILDBEREICH-45+45*24*9)
	ldi XH, HIGH(adr_TV_BILDBEREICH-45+45*24*9)
	STS(adr_GRAFIC_CURSOR_L),XL
	STS(adr_GRAFIC_CURSOR_H),XH
	pop XH
	pop XL
ret
;-------------------------------------------------------------------------------
ASCII_CURSOR_ZEILE_10:
	push XL
	push XH
	STS(adr_GRAFIC_CURSOR_SPALTE),NULL
	ldi XL, LOW (adr_TV_BILDBEREICH-45+45*24*10)
	ldi XH, HIGH(adr_TV_BILDBEREICH-45+45*24*10)
	STS(adr_GRAFIC_CURSOR_L),XL
	STS(adr_GRAFIC_CURSOR_H),XH
	pop XH
	pop XL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################

