; ##############################################################################
; ##############################################################################
; ##############################################################################
TV_PIN_INITIALISIERUNG:
	; auf AUSGANG								
	sbi (TV_SYNC_DDR),(TV_SYNC_PIN_NR)		; SYNC	
	sbi (TV_DATA_DDR),(TV_DATA_PIN_NR)		; DATA	
	; auf HIGH								
	sbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC	
	sbi (TV_DATA_PORT),(TV_DATA_PIN_NR)		; DATA	
	; auf LOW								
	cbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC	
	cbi (TV_DATA_PORT),(TV_DATA_PIN_NR)		; DATA	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 64s ms  TIMER																
; Alle 64 s muss eine TV-Zeile geschrieben werden								
;																				
TIM0_COMPA:
	in	SREG_KOPIE ,SREG		
	mov TEMP_KOPIE ,temp	
	mov TEMP1_KOPIE,temp1
	MOVW ZL_KOPIE,ZL		; Copy Register Word
;-------------------------------------------------------------------------------
; TAKTKORREKTUR beim INTERRUPTAUFRUF, sonst jittert das TV-BILD					
	LDS temp,TCNT2		; Kontrolltimer auslesen	
	andi temp,0b00001111
	ldi ZL, LOW(TAKTKOREKTUR_SPRUNGMARKE)
	ldi ZH,HIGH(TAKTKOREKTUR_SPRUNGMARKE)
	add ZL,temp
	adc ZH,NULL
	IJMP		; SPRUNG (Zeiger nach Z)
TAKTKOREKTUR_SPRUNGMARKE:
	nop	; 0
	nop	; 1
	nop	; 2
	nop	; 3
	nop	; 4
	nop	; 5
	nop	; 6
	nop	; 7
	nop	; 8
	nop	; 9
	nop	;10
	nop	;11
	nop	;12
	nop	;13
	nop	;14
	nop	;15
;-------------------------------------------------------------------------------
	; SOFORT SYNC L	/ 0 Volt				
	cbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC L	/ 0 Volt
;-------------------------------------------------------------------------------
; Hier legen wir fest, wie jede einzelne Zeile (1..625) 						
; beschaffen ist, sieht zwar etwas seltsam aus, 								
; aber dafr werden immer die gleiche Anzahl von Takten bentigt und 			
; man erspart sich eine Menge Rechner- und Ausgleicherei.						
;																				
; Ein TV Bild besteht aus 625 Zeilen (BRUTTO).									
; Das erste Halbbild:         1...312,5 = 312,5 ZEILEN							
; Das zweite Halbbild:    312,5...625   = 312,5 ZEILEN							
;																				
; Nutzbare Zeilen:   	   23,5...310 	 = 287,5 ZEILEN							
;				     	    336...623,5 = 288,5	 ZEILEN							
;  																				
; TV-BILD: 320x256=81.920 PIXEL ---> :8=10.240 BYTE SRAM						
;																				
	;**********	 BILD erzeugen	**********	
	; ZEILENNUMMER +1						
	add TV_ZEILE_NR_L,EINS
	adc TV_ZEILE_NR_H,NULL
	; Z-ZEIGER initialisieren				
	mov ZL,TV_ZEILE_NR_L
	mov ZH,TV_ZEILE_NR_H
	ldi temp, LOW (BILDAUFBAU_SPRUNGMARKE)
	ldi temp1,HIGH(BILDAUFBAU_SPRUNGMARKE)
	add ZL,temp
	adc ZH,temp1
	IJMP		; SPRUNG (Zeiger nach Z)	
;-------------------------------------------------------------------------------
BILDAUFBAU_SPRUNGMARKE:
	; 1. Halbbild																
	rjmp ZEILE_HAUPTIMPULSE_INITIALISIERUNG ;1 (HAUPTIMPULSE+INITIALISIERUNG)	
	rjmp ZEILE_HAUPTIMPULSE					;2 (HAUPTIMPULSE)				
	rjmp ZEILE_HAUPTIMPULS_NACHTRABANT_Z3	;3 (HAUPTIMPULS/NACHTRABANT)	
	rjmp ZEILE_TRABANTEN					;4 (TRABANTEN)					
	rjmp ZEILE_TRABANTEN					;5 (TRABANTEN)					
	MACRO_TV_ZEILE_NULL_10					;6 (Zeilen ohne INHALT)			
	MACRO_TV_ZEILE_NULL_10 					;16
	MACRO_TV_ZEILE_NULL_10					;26
	MACRO_TV_ZEILE_NULL_1 					;36
	MACRO_TV_ZEILE_NULL_1 					;37
	MACRO_TV_ZEILE_NULL_1 					;38
	MACRO_TV_ZEILE_NULL_1 					;39
	MACRO_TV_ZEILE_NULL_1 					;40
	MACRO_TV_ZEILE_NULL_1 					;41
	MACRO_TV_ZEILE_NULL_1 					;42
	rjmp ZEILE_NULL_UND_DATA_INITIALISIERUNG;43
	MACRO_TV_ZEILE_DATA_256					;44 (256 DATA-ZEILEN)		
	MACRO_TV_ZEILE_NULL_10					;300
	MACRO_TV_ZEILE_NULL_1 					;310
	rjmp ZEILE_TRABANTEN					;311 (TRABANTEN)					
	rjmp ZEILE_TRABANTEN					;312 (TRABANTEN)					
	; 2. Halbbild																
	rjmp ZEILE_TRABANT_HAUPTIMPULS_Z313		;313 (TRABANT/HAUPTIMPULS)	
	rjmp ZEILE_HAUPTIMPULSE					;314 (HAUPTIMPULSE)			
	rjmp ZEILE_HAUPTIMPULSE					;315 (HAUPTIMPULSE)			
	rjmp ZEILE_TRABANTEN					;316 (TRABANTEN)			
	rjmp ZEILE_TRABANTEN					;317 (TRABANTEN)			
	MACRO_TV_ZEILE_NULL_10					;318
	MACRO_TV_ZEILE_NULL_10 					;328
	MACRO_TV_ZEILE_NULL_10					;338
	MACRO_TV_ZEILE_NULL_1 					;348
	MACRO_TV_ZEILE_NULL_1 					;349
	MACRO_TV_ZEILE_NULL_1 					;350
	MACRO_TV_ZEILE_NULL_1 					;351
	MACRO_TV_ZEILE_NULL_1 					;352
	MACRO_TV_ZEILE_NULL_1 					;353
	MACRO_TV_ZEILE_NULL_1 					;354
	MACRO_TV_ZEILE_NULL_1 					;355
	rjmp ZEILE_NULL_UND_DATA_INITIALISIERUNG;356
	MACRO_TV_ZEILE_DATA_256					;357 (256 DATA-ZEILEN)		
	MACRO_TV_ZEILE_NULL_10					;613
	rjmp ZEILE_SYNCHRONIMPULS_TRABANT_Z623	;623 (SYNC+TRABANT)			
	rjmp ZEILE_TRABANTEN					;624 (TRABANTEN)			
	rjmp ZEILE_TRABANTEN					;625 (TRABANTEN)			
	rjmp ZEILE_HAUPTIMPULSE_INITIALISIERUNG ;1 (HAUPTIMPULSE+INITIALISIERUNG)	
BILDAUFBAU_FERTIG:
;-------------------------------------------------------------------------------
	OUT	SREG ,SREG_KOPIE		
	mov TEMP ,temp_KOPIE
	mov TEMP1,temp1_KOPIE	    			
	MOVW ZL,ZL_KOPIE 	; Copy Register Word
reti
; ##############################################################################
; ##############################################################################
; ##############################################################################
; HAUPTIMPULSE																	
; und ZEILENNUMMER-INITIALISIERUNG												
ZEILE_HAUPTIMPULSE_INITIALISIERUNG:
	; HAUPTIMPULS							
	rcall WAIT_27_3us
	sbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC H	/ 0,3 Volt / 4,7s		
	rcall WAIT_4_7us
	; HAUPTIMPULS							
	cbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC L	/ 0 Volt   / 27,3s		
	rcall WAIT_27_3us
	sbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC H	/ 0,3 Volt 				
	; ZEILENNUMMER RESET					
	clr TV_ZEILE_NR_L
	clr TV_ZEILE_NR_H
rjmp BILDAUFBAU_FERTIG
; ##############################################################################
; ##############################################################################
; ##############################################################################
; HAUPTIMPULSE																	
ZEILE_HAUPTIMPULSE:
	; HAUPTIMPULS							
	rcall WAIT_27_3us
	sbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC H	/ 0,3 Volt / 4,7s		
	rcall WAIT_4_7us
	; HAUPTIMPULS							
	cbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC L	/ 0 Volt   / 27,3s		
	rcall WAIT_27_3us
	sbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC H	/ 0,3 Volt 				
rjmp BILDAUFBAU_FERTIG
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ZEILE-3																		
; HAUPTIMPULS / TRABANT															
ZEILE_HAUPTIMPULS_NACHTRABANT_Z3:
	; HAUPTIMPULS							
	rcall WAIT_27_3us
	sbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC H	/ 0,3 Volt / 4,7s		
	rcall WAIT_4_7us
	; TRABANT								
	cbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC L	/ 0 Volt / 2,35s		
	rcall WAIT_2_35us
	sbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC H	/ 0,3 Volt 				
rjmp BILDAUFBAU_FERTIG
; ##############################################################################
; ##############################################################################
; ##############################################################################
; TRABANTEN																		
ZEILE_TRABANTEN:
	; TRABANT								
	rcall WAIT_2_35us
	sbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC H	/ 0,3 Volt / 29,65s	
	rcall WAIT_29_65us
	; TRABANT								
	cbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC L	/   0 Volt / 2,35s		
	rcall WAIT_2_35us
	sbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC H	/ 0,3 Volt 				
rjmp BILDAUFBAU_FERTIG
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ZEILE-313																		
; TRABANT + HAUPTIMPULS															
ZEILE_TRABANT_HAUPTIMPULS_Z313:
	; TRABANT								
	rcall WAIT_2_35us
	sbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC H	/ 0,3 Volt / 29,65s	
	rcall WAIT_29_65us
	; HAUPTIMPULS							
	cbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC L	/ 0 Volt  /  29,65s	
	rcall WAIT_29_65us
	sbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC H	/ 0,3 Volt 				

;-------------------------------------------------------------------------------
	; ZEILEN-NR-CHECK		
	mov ZL,TV_ZEILE_NR_L
	mov ZH,TV_ZEILE_NR_H
	cpi ZH,HIGH(313-1)
	brne ZEILE_TRABANT_HAUPTIMPULS_Z313_ERROR
	cpi ZL,LOW (313-1)
	brne ZEILE_TRABANT_HAUPTIMPULS_Z313_ERROR
rjmp BILDAUFBAU_FERTIG
;-------------------------------------------------------------------------------
ZEILE_TRABANT_HAUPTIMPULS_Z313_ERROR:
	cbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  an	
rjmp BILDAUFBAU_FERTIG
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ZEILE-623																		
; SYNCHRONIMPULS + TRABANT														
ZEILE_SYNCHRONIMPULS_TRABANT_Z623:
	; SYNCHRONIMPULS						
	rcall WAIT_4_7us
	sbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC H	; 0,3 Volt 				
	; TRABANT								
	rcall WAIT_29_65us
	cbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC L	/ 0 Volt   / 2,35s		
	rcall WAIT_2_35us
	sbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC H	/ 0,3 Volt 				
;-------------------------------------------------------------------------------
	; ZEILEN-NR-CHECK		
	mov ZL,TV_ZEILE_NR_L
	mov ZH,TV_ZEILE_NR_H
	cpi ZH,HIGH(623-1)
	brne ZEILE_SYNCHRONIMPULS_TRABANT_Z623_ERROR
	cpi ZL,LOW (623-1)
	brne ZEILE_SYNCHRONIMPULS_TRABANT_Z623_ERROR
rjmp BILDAUFBAU_FERTIG
;-------------------------------------------------------------------------------
ZEILE_SYNCHRONIMPULS_TRABANT_Z623_ERROR:
	cbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  an	
rjmp BILDAUFBAU_FERTIG
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Leere Zeile ausgeben 															
ZEILE_NULL:
	; SYNCHRONIMPULS						
	rcall WAIT_4_7us
	sbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC H	; 0,3 Volt 				
rjmp BILDAUFBAU_FERTIG
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Leere Zeile ausgeben	und  DATA-RESET (ZEIGER auf DATENFELD)					
ZEILE_NULL_UND_DATA_INITIALISIERUNG:
	; SYNCHRONIMPULS						
	rcall WAIT_4_7us
	sbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC H	; 0,3 Volt 				
	; DATA-RESET							
	ldi ZL, LOW (adr_TV_BILDBEREICH)
	ldi ZH, HIGH(adr_TV_BILDBEREICH)
	STS(adr_TV_ZEIGER_DATA_L),ZL
	STS(adr_TV_ZEIGER_DATA_H),ZH
rjmp BILDAUFBAU_FERTIG
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Eine TV-ZEILE schreiben														
; 45-Bytes (45x8=360PIXEL)														
ZEILE_DATA_Z:
	; SYNCHRONIMPULS (0V)				
	rcall WAIT_4_7us
	sbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC H
;-----------------------------------------										
; hintere SCHWARZschulter 														
; Sie muss mindestens 5,8s betragen, bevor Bilddaten gesendet werden knnen.	
; Die Zeitvorgabe wird aber erfllt, durch den taktintensiven TV-ZEILEN-CHECK !	
	; BILD positionieren (linker RAND)	
;	call wait_5_8us
;	call wait_1us
;-----------------------------------------										
; TURBO-MODUS, liegen DATEN in der TV-Zeile vor?								
	LDS ZL,(adr_TV_ZEIGER_DATA_L)	; ZEIGER-DATA laden					
	LDS ZH,(adr_TV_ZEIGER_DATA_H)
	clr temp1
	LD temp,Z+
	OR temp1,temp
	LD temp,Z+
	OR temp1,temp
	LD temp,Z+
	OR temp1,temp
	LD temp,Z+
	OR temp1,temp
	LD temp,Z+
	OR temp1,temp
	LD temp,Z+
	OR temp1,temp
	LD temp,Z+
	OR temp1,temp
	LD temp,Z+
	OR temp1,temp
	LD temp,Z+
	OR temp1,temp
	LD temp,Z+
	OR temp1,temp	; 10
	LD temp,Z+
	OR temp1,temp
	LD temp,Z+
	OR temp1,temp
	LD temp,Z+
	OR temp1,temp
	LD temp,Z+
	OR temp1,temp
	LD temp,Z+
	OR temp1,temp
	LD temp,Z+
	OR temp1,temp
	LD temp,Z+
	OR temp1,temp
	LD temp,Z+
	OR temp1,temp
	LD temp,Z+
	OR temp1,temp
	LD temp,Z+
	OR temp1,temp	; 10
	LD temp,Z+
	OR temp1,temp
	LD temp,Z+
	OR temp1,temp
	LD temp,Z+
	OR temp1,temp
	LD temp,Z+
	OR temp1,temp
	LD temp,Z+
	OR temp1,temp
	LD temp,Z+
	OR temp1,temp
	LD temp,Z+
	OR temp1,temp
	LD temp,Z+
	OR temp1,temp
	LD temp,Z+
	OR temp1,temp
	LD temp,Z+
	OR temp1,temp	; 10
	LD temp,Z+
	OR temp1,temp
	LD temp,Z+
	OR temp1,temp
	LD temp,Z+
	OR temp1,temp
	LD temp,Z+
	OR temp1,temp
	LD temp,Z+
	OR temp1,temp
	LD temp,Z+
	OR temp1,temp
	LD temp,Z+
	OR temp1,temp
	LD temp,Z+
	OR temp1,temp
	LD temp,Z+
	OR temp1,temp
	LD temp,Z+
	OR temp1,temp	; 10
	LD temp,Z+
	OR temp1,temp
	LD temp,Z+
	OR temp1,temp
	LD temp,Z+
	OR temp1,temp
	LD temp,Z+
	OR temp1,temp
	LD temp,Z+
	OR temp1,temp
;-----------------------------------------										
	tst temp1
	brne ZEILE_DATA_Z_RUN
	STS(adr_TV_ZEIGER_DATA_L),ZL			; ZEIGER-DATA save							
	STS(adr_TV_ZEIGER_DATA_H),ZH
jmp BILDAUFBAU_FERTIG
;-----------------------------------------										
; TV-ZEILE komplett schreiben													
ZEILE_DATA_Z_RUN:
	LDS ZL,(adr_TV_ZEIGER_DATA_L)	; ZEIGER-DATA laden					
	LDS ZH,(adr_TV_ZEIGER_DATA_H)
	; jeweils ein DATENBYTE ausgeben	
	MACRO_TV_DATA_Z	; 1
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z	; 10
	MACRO_TV_DATA_Z	
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z	; 20
	MACRO_TV_DATA_Z	
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z	; 30
	MACRO_TV_DATA_Z	
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z	; 40
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z	; 45
	; DUNKEL									
	nop
	cbi (TV_DATA_PORT),(TV_DATA_PIN_NR)		; DATA L
	STS(adr_TV_ZEIGER_DATA_L),ZL			; ZEIGER-DATA save							
	STS(adr_TV_ZEIGER_DATA_H),ZH
jmp BILDAUFBAU_FERTIG
; ##############################################################################
; ##############################################################################
; ##############################################################################

