; ##############################################################################
; ##############################################################################
; ##############################################################################
;																				
; Ein Byte aus EEPROM holen und Z-Zeiger + 1									
;																				
; INPUT:	ZL Adresse (low)													
;			ZH Adresse (High)													
;																				
; OUTPUT: 	TEMP (DATEN)														
;																				
EEPROM_READ_Z_TEMP:
	sbic EECR,EEPE	; Wait for completion of previous write
	rjmp EEPROM_READ_Z_TEMP
	out EEARH, ZH	; ADRESSE						
	out EEARL, ZL
	sbi EECR,EERE	; Start eeprom read 			
	in temp,EEDR 	; Read data 					
	adiw ZL,1		; ADRESSE +1 					
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
;																				
; Ein Byte im EEPROM ablegen und Z-Zeiger + 1									
;																				
; INPUT:	ZL Adresse (low)													
;			ZH Adresse (High)													
;																				
; 		 	TEMP  DATEN															
;																				
EEPROM_WRITE_Z_TEMP:
	sbic EECR,EEPE	; Wait for completion of previous write
	rjmp EEPROM_WRITE_Z_TEMP
	out EEARH, ZH	; Adresse								
	out EEARL, ZL	
	adiw ZL,1		; ADRESSE +1 							
;-------------------------------------------------------------------------------
	sbi EECR,EERE	; Start eeprom read 			
	in R0,EEDR 		; Read data 					
	cp temp,R0
	brne EEPROM_WRITE_Z_TEMP_w
	ret
;-------------------------------------------------------------------------------
EEPROM_WRITE_Z_TEMP_w:
	out EEDR,temp	; Write data							
	sbi EECR,EEMPE	; Write logical one to EEMPE			
	sbi EECR,EEPE 	; Start eeprom write by setting EEPE	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
EEPROM_KONFIGURATION_SPEICHERN:
	; Z-ADRESSE								
	ldi ZL, LOW(eep_EEPROM_WERKSEINSTELLUNG)
	ldi ZH,HIGH(eep_EEPROM_WERKSEINSTELLUNG)
	; VERSION								
	ldi temp,(VERSION)
	rcall EEPROM_WRITE_Z_TEMP
	; BMA020_ALARM_SCHWELLE					
	LDS temp,(adr_BMA020_ALARM_SCHWELLE)
	rcall EEPROM_WRITE_Z_TEMP
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
EEPROM_KONFIGURATION_LADEN:
	; Z-ADRESSE								
	ldi ZL, LOW(eep_EEPROM_WERKSEINSTELLUNG)
	ldi ZH,HIGH(eep_EEPROM_WERKSEINSTELLUNG)
	; VERSION								
	rcall EEPROM_READ_Z_TEMP		; read	0
	cpi temp,(VERSION)
	breq EEPROM_KONFIGURATION_LADEN_RUN
	ret
;-------------------------------------------------------------------------------
EEPROM_KONFIGURATION_LADEN_RUN:
	; ANZEIGE-SONNEN-AUFGANG-UNTERGANG		
	rcall EEPROM_READ_Z_TEMP		; read	0
	STS(adr_BMA020_ALARM_SCHWELLE),temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
