; ##############################################################################
; ##############################################################################
; ##############################################################################
DIAGRAMM_INITIALISIERUNG:
	call GRAFIC_CLEAR
	call ASCII_CURSOR_ZEILE_5
	call ASCII_SPACE10
	call ASCII_SPACE10
	call ASCII_X
	call ASCII_CURSOR_ZEILE_7
	call ASCII_SPACE10
	call ASCII_SPACE10
	call ASCII_Y
	call ASCII_CURSOR_ZEILE_9
	call ASCII_SPACE10
	call ASCII_SPACE10
	call ASCII_Z
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
DIAGRAMM_BERECHNUNG_ALARM:
	LDS temp,(adr_BMA020_ALARM_TIMER)
	cpi temp,255
	breq DIAGRAMM_BERECHNUNG_ALARM_w
	ret
;-------------------------------------------------------------------------------
DIAGRAMM_BERECHNUNG_ALARM_w:
	LDS temp1,(adr_BMA020_X_L)
	LDS temp2,(adr_BMA020_X_H)
	rcall DIAGRAMM_BERECHNUNG_TEMP1_TEMP2
	LDS temp1,(adr_BMA020_Y_L)
	LDS temp2,(adr_BMA020_Y_H)
	rcall DIAGRAMM_BERECHNUNG_TEMP1_TEMP2
	LDS temp1,(adr_BMA020_Z_L)
	LDS temp2,(adr_BMA020_Z_H)
	rcall DIAGRAMM_BERECHNUNG_TEMP1_TEMP2
	ret
;-------------------------------------------------------------------------------
; BERECHNUNG																	
DIAGRAMM_BERECHNUNG_TEMP1_TEMP2:
	tst temp2
	brpl DIAGRAMM_BERECHNUNG_TEMP1_TEMP2_p
	com temp1
	com temp2
	add temp1,EINS
	adc temp2,NULL
DIAGRAMM_BERECHNUNG_TEMP1_TEMP2_p:
	tst temp2
	brne DIAGRAMM_ALARM_MARKIERUNG
	LDS temp,(adr_BMA020_ALARM_SCHWELLE)
	cp temp1,temp
	brsh DIAGRAMM_ALARM_MARKIERUNG
	ret
;-------------------------------------------------------------------------------
; MARKIERUNG																	
DIAGRAMM_ALARM_MARKIERUNG:
	cbi (LED_GELB_PORT),LED_GELB_PIN_NR			; GELB an	
	; ZEITSTEMPEL			
	LDS temp1,(adr_ss)
	LDS temp2,(adr_mm)
	LDS temp3,(adr_hh)
	LDS temp4,(adr_TAG)
	LDS temp5,(adr_MONAT)
	LDS temp6,(adr_JAHR)
	LDS temp7,(adr_WOCHENTAG)
	STS(adr_ZEITSTEMPEL_ss),temp1
	STS(adr_ZEITSTEMPEL_mm),temp2
	STS(adr_ZEITSTEMPEL_hh),temp3
	STS(adr_ZEITSTEMPEL_TAG),temp4
	STS(adr_ZEITSTEMPEL_MONAT),temp5
	STS(adr_ZEITSTEMPEL_JAHR),temp6
	STS(adr_ZEITSTEMPEL_WOCHENTAG),temp7
	; ALARM-TIMER			
	ldi temp,254
	STS(adr_BMA020_ALARM_TIMER),temp
	; MARKIERUNG			
	ldi temp,0b10000000
	STS(adr_TV_BILDBEREICH_ENDE-45*1),temp
	STS(adr_TV_BILDBEREICH_ENDE-45*2),temp
	STS(adr_TV_BILDBEREICH_ENDE-45*3),temp
	STS(adr_TV_BILDBEREICH_ENDE-45*4),temp
	STS(adr_TV_BILDBEREICH_ENDE-45*5),temp
	STS(adr_TV_BILDBEREICH_ENDE-45*6),temp
	STS(adr_TV_BILDBEREICH_ENDE-45*7),temp
	STS(adr_TV_BILDBEREICH_ENDE-45*8),temp
	STS(adr_TV_BILDBEREICH_ENDE-45*9),temp
	STS(adr_TV_BILDBEREICH_ENDE-45*10),temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
DIAGRAMM_ZEICHNEN:
	; TIMER-AUSWERTUNG			
	LDS temp,(adr_BMA020_ALARM_TIMER)
	cpi temp,255
	breq DIAGRAMM_ZEICHNEN_w1	; Uhr luft	
	cpi temp,1
	breq DIAGRAMM_ZEICHNEN_w3	; SAVE		
	tst temp
	brne DIAGRAMM_ZEICHNEN_w2	; Uhr steht, aber TIMER dec		
	ret
;-------------------------------------------------------------------------------
DIAGRAMM_ZEICHNEN_w3:
	call DIAGRAMM_SAVE
ret
;-------------------------------------------------------------------------------
DIAGRAMM_ZEICHNEN_w2:
	dec temp
	STS(adr_BMA020_ALARM_TIMER),temp
	rjmp DIAGRAMM_ZEICHNEN_RUN
;-------------------------------------------------------------------------------
DIAGRAMM_ZEICHNEN_w1:
	; ZEIT+DATUM				
	LDS temp,(adr_FREIGABE_DIAGRAMM_ZEIT)
	SBRS temp,0
	rjmp DIAGRAMM_ZEICHNEN_RUN
	STS(adr_FREIGABE_DIAGRAMM_ZEIT),NULL
	call ASCII_CURSOR_ZEILE_1
	call ANZEIGE_DATUM_KURZ		; DATUM		
	call ASCII_SPACE2
	call ANZEIGE_WOCHENTAG_KURZ	; Wochentag	
	call ASCII_SPACE2
	call ANZEIGE_ZEIT_KURZ		; ZEIT		
;-------------------------------------------------------------------------------
DIAGRAMM_ZEICHNEN_RUN:
	; SEKUNDENMARKIERUNG unten	
	LDS temp,(adr_FREIGABE_DIAGRAMM_MARKIERUNG)
	SBRS temp,0
	rjmp DIAGRAMM_ZEICHNEN_RUN_w 
	STS(adr_FREIGABE_DIAGRAMM_MARKIERUNG),NULL
	LDS temp,(adr_TV_BILDBEREICH_ENDE)
	ori temp,0b10000000
	STS(adr_TV_BILDBEREICH_ENDE),temp
;-------------------------------------------------------------------------------
DIAGRAMM_ZEICHNEN_RUN_w:
	rcall DATA_SCHEIBEN

	ldi XL,LOW (360-1)		; positionieren	X
	ldi XH,HIGH(360-1)

	LDS YL,(adr_BMA020_X_L)
	LDS YH,(adr_BMA020_X_H)
	subi YL, LOW (-150)		; positionieren	Y
	sbci YH, HIGH(-150)
	rcall GRAFIC_PUNKT_X_Y

	LDS YL,(adr_BMA020_Y_L)
	LDS YH,(adr_BMA020_Y_H)
	subi YL, LOW (-100)		; positionieren	Y
	sbci YH, HIGH(-100)
	rcall GRAFIC_PUNKT_X_Y

	LDS YL,(adr_BMA020_Z_L)
	LDS YH,(adr_BMA020_Z_H)
	subi YL, LOW (-50)		; positionieren	Y
	sbci YH, HIGH(-50)
	rcall GRAFIC_PUNKT_X_Y

	rjmp DIAGRAMM_SCHIEBEN
; ##############################################################################
; ##############################################################################
; ##############################################################################
; SCHIEBEREGISTER																
DATA_SCHEIBEN:
	ldi XL,LOW (adr_DATA_X_360+1)
	ldi XH,HIGH(adr_DATA_X_360+1)
	ldi YL,LOW (adr_DATA_Y_360+1)
	ldi YH,HIGH(adr_DATA_Y_360+1)
	ldi ZL,LOW (adr_DATA_Z_360+1)
	ldi ZH,HIGH(adr_DATA_Z_360+1)

	; SCHLEIFE			
	ldi temp8,LOW (360)	
	ldi temp9,HIGH(360)	
	inc temp9
DATA_SCHEIBEN_s:
	LD temp,X	; laden		
	ST -X,temp	; -1 write	
	adiw XL,2	; +2		

	LD temp,Y	; laden		
	ST -Y,temp	; -1 write	
	adiw YL,2	; +2		

	LD temp,Z	; laden		
	ST -Z,temp	; -1 write	
	adiw ZL,2	; +2		

	dec temp8
	brne DATA_SCHEIBEN_s
	dec temp9
	brne DATA_SCHEIBEN_s
;-------------------------------------------------------------------------------
	; aktuellen WERT speichern	
	LDS temp,(adr_BMA020_X)
	STS (adr_DATA_X_360+360-1),temp
	LDS temp,(adr_BMA020_Y)
	STS (adr_DATA_Y_360+360-1),temp
	LDS temp,(adr_BMA020_Z)
	STS (adr_DATA_Z_360+360-1),temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
DIAGRAMM_SAVE:
	; EEPROM vorhanden ?
	ldi temp1,(EEPROM_ADRESSE_A)
	call TWI_MASTER_TRANSMITTER_START_TEMP1
	call TWI_STOP
	tst TWI_FEHLER_CODE
	breq DIAGRAMM_SAVE_RUN 
	ret
;-------------------------------------------------------------------------------
DIAGRAMM_SAVE_RUN:
	call ASCII_CURSOR_ZEILE_2
	call ASCII_S
	call ASCII_A
	call ASCII_V
	call ASCII_E
	call ASCII_MINUS
	call ASCII_N
	call ASCII_R
	call ASCII_DOPPEL_PUNKT
	call ASCII_SPACE

	call TWI_EEPROM_DIAGRAMM_SEARCH_FREE_Z
	call TWI_EEPROM_DIAGRAMM_SAVE_Z

	ldi temp,255
	STS(adr_BMA020_ALARM_TIMER),temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
DIAGRAMM_LOAD_TEMP1:
	; negativ ?						
	tst temp1
	brpl DIAGRAMM_LOAD_TEMP1_OK
	ldi temp1,(ANZ_DIAGRAMM_SPEICHERPLAETZE-1)
	STS (adr_DIAGRAMM_NR),temp1
;-------------------------------------------------------------------------------
DIAGRAMM_LOAD_TEMP1_OK:
	; berlauf ?						
	cpi temp1,(ANZ_DIAGRAMM_SPEICHERPLAETZE)
	brlo DIAGRAMM_LOAD_TEMP1_START
	clr temp1
	STS (adr_DIAGRAMM_NR),temp1
;-------------------------------------------------------------------------------
DIAGRAMM_LOAD_TEMP1_START:
	clr ZL
	clr ZH
	; DIAGRAMM-NUMMER NULL?			
	tst temp1
	breq DIAGRAMM_LOAD_TEMP1_RUN
;-------------------------------------------------------------------------------
DIAGRAMM_LOAD_TEMP1_s:
	subi ZL, LOW (-1090)	
	sbci ZH, HIGH(-1090)	
	dec temp1
	brne DIAGRAMM_LOAD_TEMP1_s
;-------------------------------------------------------------------------------
DIAGRAMM_LOAD_TEMP1_RUN:
	call TWI_EEPROM_DIAGRAMM_LOAD_Z
;-------------------------------------------------------------------------------
	; DIAGRAMM-NUMMER				
	call ASCII_CURSOR_ZEILE_2
	call ASCII_N
	call ASCII_r_
	call ASCII_MINUS
	LDS temp1,(adr_DIAGRAMM_NR)
	call ANZEIGE_2_STELLEN_TEMP1
	; ZEITSTEMPEL					
	call ASCII_CURSOR_ZEILE_1
	LDS temp1,(adr_ZEITSTEMPEL_TAG)			; TAG		
	call ANZEIGE_2_STELLEN_TEMP1
	call ASCII_PUNKT
	LDS temp1,(adr_ZEITSTEMPEL_MONAT)		; MONAT		
	call ANZEIGE_2_STELLEN_TEMP1
	call ASCII_PUNKT
	LDS temp1,(adr_ZEITSTEMPEL_JAHR)		; JAHR		
	call ANZEIGE_2_STELLEN_TEMP1
	call ASCII_SPACE2
	LDS temp,(adr_ZEITSTEMPEL_WOCHENTAG)	; Wochentag	
	call ANZEIGE_WOCHENTAG_KURZ_TEMP
	call ASCII_SPACE2
	LDS temp1,(adr_ZEITSTEMPEL_hh)			; hh		
	call ANZEIGE_2_STELLEN_TEMP1
	call ASCII_DOPPEL_PUNKT
	LDS temp1,(adr_ZEITSTEMPEL_mm)			; mm		
	call ANZEIGE_2_STELLEN_TEMP1
	call ASCII_DOPPEL_PUNKT	
	LDS temp1,(adr_ZEITSTEMPEL_ss)			; ss		
	call ANZEIGE_2_STELLEN_TEMP1
	; X-Y-Z-Kurven					
	ldi ZL,LOW (adr_DATA_X_360)	; Z-INITIALISIEREN	
	ldi ZH,HIGH(adr_DATA_X_360)
	ldi temp7,150				; positionieren	Y		
	rcall DIAGRAMM_LOAD_KURVE
	ldi ZL,LOW (adr_DATA_Y_360)	; Z-INITIALISIEREN	
	ldi ZH,HIGH(adr_DATA_Y_360)
	ldi temp7,100				; positionieren	Y	
	rcall DIAGRAMM_LOAD_KURVE
	ldi ZL,LOW (adr_DATA_Z_360)	; Z-INITIALISIEREN	
	ldi ZH,HIGH(adr_DATA_Z_360)
	ldi temp7,50				; positionieren	Y	
	rcall DIAGRAMM_LOAD_KURVE
ret
;-------------------------------------------------------------------------------
DIAGRAMM_LOAD_KURVE:
	clr XL						; positionieren	X	
	clr XH
	ldi temp8,LOW (360)			; SCHLEIFE			
	ldi temp9,HIGH(360)
	inc temp9
DIAGRAMM_LOAD_s:
	MOV YL,temp7				; positionieren	Y	
	MOV YH,NULL
	LD temp,Z+	
	; negativ	
	tst temp
	brpl DIAGRAMM_LOAD_P
	com temp
	inc temp
	sub YL,temp
	sbc YH,NULL
	rjmp DIAGRAMM_LOAD_w
DIAGRAMM_LOAD_P:
	add YL,temp
	adc YH,NULL
DIAGRAMM_LOAD_w:
	rcall GRAFIC_PUNKT_X_Y
	adiw XL,1					; X+1				
	dec temp8
	brne DIAGRAMM_LOAD_s
	dec temp9
	brne DIAGRAMM_LOAD_s
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
.MACRO MACRO_SCHIEBEN_BYTES10
	MACRO_SCHIEBEN_BYTES
	MACRO_SCHIEBEN_BYTES
	MACRO_SCHIEBEN_BYTES
	MACRO_SCHIEBEN_BYTES
	MACRO_SCHIEBEN_BYTES
	MACRO_SCHIEBEN_BYTES
	MACRO_SCHIEBEN_BYTES
	MACRO_SCHIEBEN_BYTES
	MACRO_SCHIEBEN_BYTES
	MACRO_SCHIEBEN_BYTES
.endm
; ##############################################################################
.MACRO MACRO_SCHIEBEN_BYTES
	LD temp,Z	; laden				
	ROR temp	; rechts ber Carry	
	ST Z,temp	; speichern			
	LD R0,-Z	; DUMMY Z-1			
.endm
; ##############################################################################
; ##############################################################################
; ##############################################################################
; nur den Diagramm-Bereich schieben, aber nicht die obere ASCII-ZEILE			
DIAGRAMM_SCHIEBEN:
	; Z auf Bildbereich-ENDE
	ldi ZL,LOW (adr_TV_BILDBEREICH_ENDE)
	ldi ZH,HIGH(adr_TV_BILDBEREICH_ENDE)
	ldi temp9,232	; (256-24)
DIAGRAMM_SCHIEBEN_s:
	rcall DIAGRAMM_SCHIEBEN_ZEILE
	dec temp9
	brne DIAGRAMM_SCHIEBEN_s
ret
;-------------------------------------------------------------------------------
DIAGRAMM_SCHIEBEN_ZEILE:
	CLC	; Clear Carry
	MACRO_SCHIEBEN_BYTES10
	MACRO_SCHIEBEN_BYTES10
	MACRO_SCHIEBEN_BYTES10
	MACRO_SCHIEBEN_BYTES10
	MACRO_SCHIEBEN_BYTES
	MACRO_SCHIEBEN_BYTES
	MACRO_SCHIEBEN_BYTES
	MACRO_SCHIEBEN_BYTES
	MACRO_SCHIEBEN_BYTES
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
