; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Setzt oder lscht einen Punkt an den Koordinaten X,Y							
;																				
; INP:																			
;		XL+XH	(links unten: X=0 	Y=0)	(Bereich: 0...359)					
;		YL+YH	(rechts oben: X=319 Y=255)	(Bereich: 0...255)					
;																				
; REGISTER:																		
; 	R0+R1+R2+R3+R4+R5:	Hilfsregister (wird aber nicht gesichert !!! wegen Zeitersparnis)	
; 	temp: 	Hilfsregister (wird aber nicht gesichert !!!)						
; 	ZL+ZH:	Hilfsregister 														
;																				
GRAFIC_PUNKT_X_Y:
	; PUNKTGROESSE		
	LDS R5,(adr_GRAFIC_PUNKT_GROESSE)
	tst R5
	breq GRAFIC_PUNKT_X_Y_START
	rjmp GRAFIC_PUNKT_X_Y_GROESSE_R5
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Y-WERT im Bereich ? 															
GRAFIC_PUNKT_X_Y_START:
	; berlauf ?	
	tst YH
	breq GRAFIC_PUNKT_X_Y_X
	ret
;-------------------------------------------------------------------------------
; X-WERT im im BEREICH ? 														
GRAFIC_PUNKT_X_Y_X:
	; berlauf ?	
	cpi XH,HIGH(TV_XSITZE-1)
	brlo  GRAFIC_PUNKT_X_Y_OK
	breq GRAFIC_PUNKT_X_Y_L
	rjmp GRAFIC_PUNKT_X_Y_ERROR_Y
GRAFIC_PUNKT_X_Y_L:
	cpi XL,LOW (TV_XSITZE-1)
	brlo GRAFIC_PUNKT_X_Y_OK
	breq GRAFIC_PUNKT_X_Y_OK
GRAFIC_PUNKT_X_Y_ERROR_Y:
	ret
;-------------------------------------------------------------------------------
GRAFIC_PUNKT_X_Y_OK:
	; SICHERUNGSKOPIE										
	push ZL
	push ZH
	; GRAFIC-SPALTE auf unten-links setzen					
	ldi ZL, LOW (adr_TV_BILDBEREICH_ENDE-44)
	ldi ZH, HIGH(adr_TV_BILDBEREICH_ENDE-44)
	; GRAFIC-SPALTE vorbereiten								
	mov R0,XL
	mov R1,XH
	LSR R1		; :2(2)
	ROR R0
	LSR R1		; :2(4)
	ROR R0
	LSR R1		; :2(8)
	ROR R0
	; GRAFIC-SPALTE bestimmen								
	add ZL,R0
	adc ZH,R1
	; GRAFIC-ZEILE vorbereiten	(Y mal 45BYTE)				
	ldi temp,45
	MUL YL,temp			; Ergebnis in R0+R1
	; GRAFIC-SPALTE und GRAFIC-ZEILE vereinen... fertsch !									
	; Nun ist uns bekannt, welche SRAM-Adresse (Z) ausgelesen werden muss					
	sub ZL,R0
	sbc ZH,R1
	; Hier lesen wir das SRAM-BYTE aus(Z) und befummeln anschlieend das entsprechende BIT	
	; mit R0 aufpassen, das brauchen wir spter noch !										
	LD R0,Z
;-------------------------------------------------------------------------------
; Nun mssen wir nur noch herausfinden, welche BIT-Position  es betrifft,			
; geht auch mit einer Tabelle, dauert aber lnger									
	; Vorbereitung		
	mov temp,XL
	andi temp,0b00000111
	; Vergleich ?		
	cpi temp,0
	breq GRAFIC_PUNKT_B0
	cpi temp,1
	breq GRAFIC_PUNKT_B1
	cpi temp,2
	breq GRAFIC_PUNKT_B2
	cpi temp,3
	breq GRAFIC_PUNKT_B3
	cpi temp,4
	breq GRAFIC_PUNKT_B4
	cpi temp,5
	breq GRAFIC_PUNKT_B5
	cpi temp,6
	breq GRAFIC_PUNKT_B6
	; entsprechende BIT ermitteln	
	ldi temp,0b10000000		; BIT-7
	rjmp GRAFIC_PUNKT_FERTIG
GRAFIC_PUNKT_B0:
	ldi temp,0b00000001		; BIT-0	
	rjmp GRAFIC_PUNKT_FERTIG
GRAFIC_PUNKT_B1:
	ldi temp,0b00000010 	; BIT-2
	rjmp GRAFIC_PUNKT_FERTIG
GRAFIC_PUNKT_B2:
	ldi temp,0b00000100		; BIT-3
	rjmp GRAFIC_PUNKT_FERTIG
GRAFIC_PUNKT_B3:
	ldi temp,0b00001000 	; BIT-4
	rjmp GRAFIC_PUNKT_FERTIG
GRAFIC_PUNKT_B4:
	ldi temp,0b00010000 	; BIT-5
	rjmp GRAFIC_PUNKT_FERTIG
GRAFIC_PUNKT_B5:
	ldi temp,0b00100000 	; BIT-6
	rjmp GRAFIC_PUNKT_FERTIG
GRAFIC_PUNKT_B6:
	ldi temp,0b01000000 	; BIT-7
GRAFIC_PUNKT_FERTIG:
;-------------------------------------------------------------------------------
	; PUNKT setzen oder lschen ?		
	LDS R1,(adr_GRAFIC_FARBE)
	SBRC R1,0		; Skip if...
	rjmp GRAFIC_PUNKT_CLEAR
;-------------------------------------------------------------------------------
	; Punkt setzen					
	or R0,temp			; (R0)verknpfen		
	ST Z,R0				; (R0)SRAM ablegen		
	; wieder herstellen				
	pop ZH
	pop ZL
	ret
;-------------------------------------------------------------------------------
GRAFIC_PUNKT_CLEAR:
	; Punkt lschen				
	com temp			; invertieren			
	and R0,temp			; (R0)verknpfen		
	ST Z,R0				; (R0)SRAM ablegen		
	; wieder herstellen				
	pop ZH
	pop ZL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; REGISTER:																		
;			R5																	
GRAFIC_PUNKT_X_Y_GROESSE_R5:
	; MITTELPUNKT					
	rcall GRAFIC_PUNKT_X_Y_START	; PUNKT setzen	
	mov temp,R5
GRAFIC_PUNKT_X_Y_GROESSE_1w:	
	cpi temp,1
	brne GRAFIC_PUNKT_X_Y_GROESSE_2w
	rjmp GRAFIC_PUNKT_X_Y_GROESSE_1
GRAFIC_PUNKT_X_Y_GROESSE_2w:
	cpi temp,2
	brne GRAFIC_PUNKT_X_Y_GROESSE_3w
	rjmp GRAFIC_PUNKT_X_Y_GROESSE_2
GRAFIC_PUNKT_X_Y_GROESSE_3w:
	cpi temp,3
	brne GRAFIC_PUNKT_X_Y_GROESSE_4w
	rjmp GRAFIC_PUNKT_X_Y_GROESSE_3
GRAFIC_PUNKT_X_Y_GROESSE_4w:
	cpi temp,4
	brne GRAFIC_PUNKT_X_Y_GROESSE_5w
	rjmp GRAFIC_PUNKT_X_Y_GROESSE_4
GRAFIC_PUNKT_X_Y_GROESSE_5w:
	cpi temp,5
	brne GRAFIC_PUNKT_X_Y_GROESSE_6w
	rjmp GRAFIC_PUNKT_X_Y_GROESSE_5
GRAFIC_PUNKT_X_Y_GROESSE_6w:
	cpi temp,6
	brne GRAFIC_PUNKT_X_Y_GROESSE_7w
	rjmp GRAFIC_PUNKT_X_Y_GROESSE_6
GRAFIC_PUNKT_X_Y_GROESSE_7w:
	cpi temp,7
	brne GRAFIC_PUNKT_X_Y_GROESSE_8w
	rjmp GRAFIC_PUNKT_X_Y_GROESSE_7
GRAFIC_PUNKT_X_Y_GROESSE_8w:
	cpi temp,8
	brne GRAFIC_PUNKT_X_Y_GROESSE_9
	rjmp GRAFIC_PUNKT_X_Y_GROESSE_8
;----------------------------------------------------------------------------------------------------
GRAFIC_PUNKT_X_Y_GROESSE_9:
	sbiw XL,8	; X-8
	sbiw YL,2	; Y-2
	rcall GRAFIC_PUNKT_X_Y_START	;1
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START	;2
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START	;3
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START	;4
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START	;5
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	;6
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START	;7
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START	;8
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	;9
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START	;10
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	;11
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START	;12
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	;13
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START	;14
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	;15
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	;16
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START	;17
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	;18
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	;19
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	;20
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	;21
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	;22
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	;23
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	;24
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	;25
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	;26
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	;27
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	;28
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	;29
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	;30
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	;31
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	;32
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	;33
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	;34
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	;35
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	;36
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	;37
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	;38
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	;39
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	;40
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	;41
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	;42
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	;43
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	;44
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	;45
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	;46
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	;47
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	;48
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	;49
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	;50
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	;51
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	;52
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	;53
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START	;54
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	;55
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	;56
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START	;57
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	;58
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START	;59
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	;60
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START	;61
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	;62
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START	;63
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START	;64
	adiw XL,7	; X+7	 wieder auf MITTELPUNKT	
	adiw YL,2	; Y+2
;----------------------------------------------------------------------------------------------------
GRAFIC_PUNKT_X_Y_GROESSE_8:
	sbiw XL,7	; X-7
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	; 1
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START	; 2
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START	; 3
	adiw YL,1	; Y+1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 4
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START	; 5
	adiw YL,1	; Y+1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 6
	adiw YL,1	; Y+1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 6A
	adiw YL,1	; Y+1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 7
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 8
	adiw YL,1	; Y+1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 9
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 10
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 11
	sbiw YL,1	; Y-1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 12
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 13
	sbiw YL,1	; Y-1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 14
	sbiw YL,1	; Y-1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 14A
	sbiw YL,1	; Y-1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 15
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	; 16
	sbiw YL,1	; Y-1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 17
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	; 18
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	; 19
	sbiw YL,1	; Y-1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	; 20
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	; 21
	sbiw YL,1	; Y-1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	; 22
	sbiw YL,1	; Y-1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	; 22A
	sbiw YL,1	; Y-1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	; 23
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	; 24
	sbiw YL,1	; Y-1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	; 25
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	; 26
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	; 27
	adiw YL,1	; Y+1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	; 28
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	; 29
	adiw YL,1	; Y+1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	; 30
	adiw YL,1	; Y+1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	; 30A
	adiw YL,1	; Y+1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	; 31
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START	; 32
	adiw XL,6	; X+6	 wieder auf MITTELPUNKT	
	adiw YL,2	; Y+2
;----------------------------------------------------------------------------------------------------
GRAFIC_PUNKT_X_Y_GROESSE_7:
	sbiw XL,6	; X-6
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	; 1
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START	; 2
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START	; 3
	adiw YL,1	; Y+1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 4
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START	; 5
	adiw YL,1	; Y+1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 6
	adiw YL,1	; Y+1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 7
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 8
	adiw YL,1	; Y+1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 9
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 10
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 11
	sbiw YL,1	; Y-1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 12
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 13
	sbiw YL,1	; Y-1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 14
	sbiw YL,1	; Y-1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 15
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	; 16
	sbiw YL,1	; Y-1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 17
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	; 18
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	; 19
	sbiw YL,1	; Y-1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	; 20
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	; 21
	sbiw YL,1	; Y-1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	; 22
	sbiw YL,1	; Y-1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	; 23
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	; 24
	sbiw YL,1	; Y-1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	; 25
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	; 26
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	; 27
	adiw YL,1	; Y+1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	; 28
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	; 29
	adiw YL,1	; Y+1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	; 30
	adiw YL,1	; Y+1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	; 31
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START	; 32
	adiw XL,5	; X+5	 wieder auf MITTELPUNKT	
	adiw YL,2	; Y+2
;----------------------------------------------------------------------------------------------------
GRAFIC_PUNKT_X_Y_GROESSE_6:
	sbiw XL,5	; X-5
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START
	adiw YL,1	; Y+1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START	; 
	adiw YL,1	; Y+1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 
	adiw YL,1	; Y+1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	 
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	 
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	 
	sbiw YL,1	; Y-1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 
	sbiw YL,1	; Y-1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	; 
	sbiw YL,1	; Y-1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START
	sbiw XL,1	; X-1
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	; 
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	; 
	sbiw XL,1	; X-1
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	; 
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	; 
	sbiw XL,1	; X-1
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START
	adiw YL,1	; Y+1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	; 
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	; 
	adiw YL,1	; Y+1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	; 
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START	; 
	adiw XL,4	; X+4	 wieder auf MITTELPUNKT	
	adiw YL,2	; Y+2
;----------------------------------------------------------------------------------------------------
GRAFIC_PUNKT_X_Y_GROESSE_5:
	sbiw XL,4	; X-4
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START
	adiw YL,1	; Y+1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START	; 
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 
	adiw YL,1	; Y+1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START
	adiw XL,1	; X+1
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	; 
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	; 
	adiw XL,1	; X+1
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START
	sbiw YL,1	; Y-1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	; 
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	; 
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	; 
	sbiw YL,1	; Y-1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START
	sbiw XL,1	; X-1
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START	; 
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	; 
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START	; 
	adiw XL,3	; X+3	 wieder auf MITTELPUNKT	
	adiw YL,2	; Y+2
;----------------------------------------------------------------------------------------------------
GRAFIC_PUNKT_X_Y_GROESSE_4:
	sbiw XL,3	; X-3
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START
	adiw YL,1	; Y+1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START	; 
	adiw YL,1	; Y+1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START
	adiw XL,1	; X+1
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START	; 
	adiw XL,1	; X+1
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START
	sbiw YL,1	; Y-1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START	; 
	sbiw YL,1	; Y-1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START
	sbiw XL,1	; X-1
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START	; 
	adiw XL,2	; X+2	 wieder auf MITTELPUNKT	
	adiw YL,2	; Y+2
;----------------------------------------------------------------------------------------------------
GRAFIC_PUNKT_X_Y_GROESSE_3:
	sbiw XL,2	; X-2
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START
	adiw YL,1	; Y+1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_X_Y_START
	adiw XL,1	; X+1
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START
	sbiw YL,1	; Y-1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_X_Y_START
	adiw XL,1	; X+1	 wieder auf MITTELPUNKT	
	adiw YL,2	; Y+2
;----------------------------------------------------------------------------------------------------
GRAFIC_PUNKT_X_Y_GROESSE_2:
	sbiw XL,1	; X-1
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START
	adiw YL,2	; Y+2
	rcall GRAFIC_PUNKT_X_Y_START
	adiw XL,2	; X+2
	rcall GRAFIC_PUNKT_X_Y_START
	sbiw YL,2	; Y-2
	rcall GRAFIC_PUNKT_X_Y_START
	sbiw XL,1	; X-1
	adiw YL,1	; Y+1
;----------------------------------------------------------------------------------------------------
GRAFIC_PUNKT_X_Y_GROESSE_1:
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START
	adiw XL,1	; X+1
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START
	sbiw XL,1	; X-1
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_X_Y_START
	sbiw XL,1	; X-1
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_X_Y_START
	adiw XL,1	; X+1	 wieder auf MITTELPUNKT	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
