; ##############################################################################
; ##############################################################################
; ##############################################################################
; TIMER0 8-BIT-TIMER															
;																				
; CS02 CS01 CS00																
;	0 	0	0 	No clock source (Timer/Counter stopped)							
;	0 	0 	1 	clkI/O/(No prescaling)											
; *	0 	1 	0 	clkI/O/8 (From prescaler)										
;	0 	1 	1 	clkI/O/64 (From prescaler)										
;	1 	0 	0 	clkI/O/256 (From prescaler)										
;	1 	0 	1 	clkI/O/1024 (From prescaler)									
;	1 	1 	0 	External clock source on T0 pin. Clock on falling edge.			
;	1 	1 	1 	External clock source on T0 pin. Clock on rising edge.			
;																				
; Mode WGM2 WGM1 WGM0 	Mode 													
; 	0 	0 	0 	 0 		Normal 													
; 	1 	0 	0 	 1 		PWM														
; *	2 	0 	1 	 0 		CTC														
; 	3 	0 	1 	 1 		Fast													
; 	5 	1 	0 	 1 		PWM														
; 	7 	1 	1 	 1 		Fast PWM												
;																				
; 64s TIMER																	
TIMER0_INITIALISIERUNG_CTC:
	; TCCR0A  Timer/Counter Control Register A		
	ldi temp, (0<<COM0A1)| (1<<COM0A0)|(0<<COM0B1)|(0<<COM0B0)|(1<<WGM01)|(0<<WGM00)
	OUT TCCR0A,temp
	; TCCR0B  Timer/Counter Control Register B		
	ldi temp, (0<<FOC0A)| (0<<FOC0B)|(0<<WGM02)|(0<<CS02)|(1<<CS01)|(0<<CS00)
	OUT TCCR0B,temp
	; TIMSK0  Timer/Counter Interrupt Mask Register
	ldi temp, (0<<OCIE0B)| (1<<OCIE0A)|(0<<TOIE0)
	STS TIMSK0,temp
	; OCR0A  Output Compare Register A				
	ldi temp,(TIMER0_CTC)
	OUT OCR0A,temp
	; STARTWERT										
	OUT TCNT0,NULL
	; auf AUSGANG (15625/2=7.812,5 Hz)									
	sbi DDRB,PB3	; PIN OC0A
;	sbi DDRB,PB4	; PIN OC0B
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; TIMER2 8-BIT-TIMER															
;																				
; CS22 CS21 CS20																
;	0 	0 	0 	No clock source (Timer/Counter stopped).						
;*	0 	0 	1 	clkT2S/(No prescaling)											
;	0 	1 	0 	clkT2S/8 (From prescaler)										
;	0 	1 	1 	clkT2S/32 (From prescaler)										
;	1 	0 	0 	clkT2S/64 (From prescaler)										
;	1 	0 	1 	clkT2S/128 (From prescaler)										
;	1 	1 	0 	clkT2S/256 (From prescaler)										
;	1 	1 	1 	clkT2S/1024 (From prescaler)									
;																				
; Fr TAKTKORREKTUR beim INTERRUPTAUFRUF										
TIMER2_INITIALISIERUNG:
	; TCCR2B  Timer/Counter Control Register B		
	ldi temp, (0<<FOC2A)| (0<<FOC2B)|(0<<CS22)|(0<<CS21)|(1<<CS20)
	STS TCCR2B,temp
	; TIMSK2  Timer/Counter Interrupt Mask Register
	ldi temp, (0<<OCIE2B)| (0<<OCIE2A)|(0<<TOIE2)
	STS TIMSK2,temp
	; STARTWERT										
	STS TCNT2,NULL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 16-BIT-TIMER																	
;																				
; CS32 CS31 CS30																
;   0 	0 	0 	No clock source (Timer/Counter stopped).						
;   0 	0 	1 	clkI/1 (No prescaling)											
; 	0 	1 	0 	clkI/8 (From prescaler)											
; *	0 	1 	1 	clkI/64 (From prescaler)										
; 	1 	0 	0 	clkI/256 (From prescaler)										
; 	1 	0 	1 	clkI/1024 (From prescaler)										
; 	1 	1 	0 	External clock source on Tn pin. Clock on falling edge.			
; 	1 	1 	1 	External clock source on Tn pin. Clock on rising edge.			
;																				
TIMER3_INITIALISIERUNG_CTC:
	; TCCR3A  Timer/Counter 3 Control Register A			
	ldi temp, (0<<COM3A1)| (1<<COM3A0)|(0<<COM3B1)|(1<<COM3B0)|(0<<WGM31)|(0<<WGM30)
	STS TCCR3A,temp
	; TCCR3B  Timer/Counter 3 Control Register B			
	ldi temp, (0<<ICNC3)| (0<<ICES3)|(0<<WGM33)|(1<<WGM32)|(0<<CS32)|(1<<CS31)|(1<<CS30)
	STS TCCR3B,temp
	; TCCR3C  Timer/Counter 3 Control Register C			
	ldi temp, (0<<FOC3A)|(0<<FOC3B)
	STS TCCR3C,temp
	; TIMSK3  Timer/Counter3 Interrupt Mask Register		
	ldi temp, (0<<ICIE3)| (0<<OCIE3B)|(1<<OCIE3A)|(0<<TOIE3)
	STS TIMSK3,temp
	; OCR3AH and OCR3AL  Output Compare Register 3 A		
	ldi temp,HIGH(TIMER3_CTC)
	STS OCR3AH,temp
	ldi temp,LOW (TIMER3_CTC)
	STS OCR3AL,temp
	; auf AUSGANG											
	;sbi DDRB,PB6	; PIN OC3A
	;sbi DDRB,PB7	; PIN OC3B
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TIM3_COMPA:
	SEI					; INTERRUPTS wieder freigeben (verschachtelter Interrupt)
	push TEMP		    ; Sichern von "TEMP" im Stack			
	in	 TEMP,SREG		; Einlesen des SREG 					
	push TEMP	    	; Schreiben von  SREG  im Stack (KOPIE)	
	push TEMP1
	push TEMP2
	rcall ZEIT_ss20		; UHR+KALENDER	
	pop temp2
	pop TEMP1
	pop	TEMP			; LESEN von SREG vom STACK (KOPIE)		
	out	SREG,TEMP		; Wiederherstellen von SREG				
	pop	TEMP			; Wiederherstellen von "TEMP"
reti
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; SEKUNDEN																		
ZEIT_ss20:
	LDS temp,(adr_ss20)	; aus SRAM laden			
	inc temp
	STS (adr_ss20),temp	; in SRAM speichern	
	cpi temp,50
	brsh ZEIT_ss
	ret	
;-------------------------------------------------------------------------------
; SEKUNDEN																		
ZEIT_ss:
	STS(adr_ss20),NULL	; in SRAM speichern	
	STS(adr_FREIGABE_DIAGRAMM_MARKIERUNG),EINS	; MARKIERUNG	
	STS(adr_FREIGABE_DIAGRAMM_ZEIT),EINS		; ZEIT+DATUM	
	LDS temp,(adr_ss)	; aus SRAM laden			
	inc temp
	STS (adr_ss),temp	; in SRAM speichern	
	cpi temp,60
	brsh ZEIT_MM
	ret	
;-------------------------------------------------------------------------------
; MINUTEN																		
ZEIT_MM:
	STS (adr_ss),NULL	; in SRAM speichern	
	STS(adr_FREIGABE_BMA020_AUTO_OFFSET),EINS	; AUTO-OFFSET
	LDS temp,(adr_mm)	; aus SRAM laden	
	inc temp
	STS (adr_mm),temp	; in SRAM speichern	
	cpi temp,60
	brsh ZEIT_HH
	ret	
;-------------------------------------------------------------------------------
; STUNDEN																		
ZEIT_HH:
	STS (adr_mm),NULL	; in SRAM speichern	
	LDS temp,(adr_hh)	; aus SRAM laden	
	inc temp
	STS (adr_hh),temp	; in SRAM speichern	
	cpi temp,24
	brsh ZEIT_TAG
	ret	
;-------------------------------------------------------------------------------
; TAG					
ZEIT_TAG:
	STS (adr_hh),NULL	; in SRAM speichern	
	; WOCHENTAG	1=MO	
	LDS temp,(adr_WOCHENTAG)
	inc temp
	STS(adr_WOCHENTAG),temp
	cpi temp,7+1
	brlo ZEIT_TAG_WOCHENTAG_OK
	STS(adr_WOCHENTAG),EINS
ZEIT_TAG_WOCHENTAG_OK:
	LDS temp,(adr_TAG)	; aus SRAM laden	
	inc temp
	STS (adr_TAG),temp	; in SRAM speichern	
	; vergleich	
	rcall ZEIT_TAGE_IM_MONAT_TEMP1
	cp temp,temp1 
	breq ZEIT_TAG_w
	brsh ZEIT_MONAT
ZEIT_TAG_w:
	ret
;-------------------------------------------------------------------------------
; MONAT					
ZEIT_MONAT:
	STS (adr_TAG),EINS	; TAG=1				
	LDS temp,(adr_MONAT); aus SRAM laden	
	inc temp
	STS (adr_MONAT),temp; in SRAM speichern	
	cpi temp,13 
	brsh ZEIT_JAHR
	ret
;-------------------------------------------------------------------------------
; JAHR					
ZEIT_JAHR:
	STS (adr_MONAT),EINS; in SRAM speichern	
	; JAHR+1			
	LDS temp,(adr_JAHR)	; aus SRAM laden	
	inc temp
	STS (adr_JAHR),temp	; in SRAM speichern	
ret
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
; OUT: temp1 (z.B. 31 fr DEZEMBER)												
; Anzahl der TAGE im Monat	
ZEIT_TAGE_IM_MONAT_TEMP1:
	; MONAT laden			
	LDS temp1,(adr_MONAT)
	; vergleich				
	cpi temp1,2			; Februar 28/29			
	breq ZEIT_TAGE_IM_MONAT_28
	cpi temp1,4			; April 30				
	breq ZEIT_TAGE_IM_MONAT_30
	cpi temp1,6			; Juni 30				
	breq ZEIT_TAGE_IM_MONAT_30
	cpi temp1,9			; September 30			
	breq ZEIT_TAGE_IM_MONAT_30
	cpi temp1,11		; November 30			
	breq ZEIT_TAGE_IM_MONAT_30
ZEIT_TAGE_IM_MONAT_31:
	ldi temp1,31		; MONATE mit 31 TAGEN	
	ret
ZEIT_TAGE_IM_MONAT_28:
	; Jahr laden					
	LDS temp1,(adr_JAHR)
	; SCHKEIFE						
ZEIT_TAGE_IM_MONAT_28s:
	; vergleich						
	subi temp1,4
	tst temp1
	; NULL=Schaltjahr				
	breq ZEIT_TAGE_IM_MONAT_29
	brpl ZEIT_TAGE_IM_MONAT_28s
	; negativ kein Schaltjahr		
	ldi temp1,28
	ret
ZEIT_TAGE_IM_MONAT_29:
	ldi temp1,29
	ret
ZEIT_TAGE_IM_MONAT_30:
	ldi temp1,30
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
