; ##############################################################################
; ##############################################################################
; ##############################################################################
; 24FC1025																		
TWI_EEPROM_CHECK:
	ldi temp1,(EEPROM_ADRESSE_A)
	call TWI_MASTER_TRANSMITTER_START_TEMP1
	call TWI_STOP
	tst TWI_FEHLER_CODE
	brne TWI_EEPROM_CHECK_ERROR
	ret
;-------------------------------------------------------------------------------
TWI_EEPROM_CHECK_ERROR:
	call GRAFIC_CLEAR
	call ASCII_T
	call ASCII_W
	call ASCII_I
	call ASCII_MINUS
	call ASCII_E
	call ASCII_E
	call ASCII_P
	call ASCII_R
	call ASCII_O
	call ASCII_M
	call ASCII_SPACE
	call ANZEIGE_TEXT_NOT_FOUND_KURZ
	call WAIT_1s
	call WAIT_1s
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TWI_EEPROM_DIAGRAMM_SEARCH_FREE_Z:
	clr ZL
	clr ZH
	clr temp9
TWI_EEPROM_DIAGRAMM_FREE_Z_s:
	rcall TWI_EEPROM_READ_Z_TEMP1
	tst temp1
	breq TWI_EEPROM_DIAGRAMM_FREE_FERTIG

	ldi temp1,LOW (1090)
	ldi temp2,HIGH(1090)
	add ZL,temp1
	adc ZH,temp2

	inc temp9
	cpi temp9,(ANZ_DIAGRAMM_SPEICHERPLAETZE)
	brlo TWI_EEPROM_DIAGRAMM_FREE_Z_s
	call TWI_EEPROM_CLEAR
	rjmp TWI_EEPROM_DIAGRAMM_SEARCH_FREE_Z
;-------------------------------------------------------------------------------
TWI_EEPROM_DIAGRAMM_FREE_FERTIG:
	STS(adr_DIAGRAMM_NR),temp9
	mov temp1,temp9
	call ANZEIGE_2_STELLEN_TEMP1
	call ASCII_SPACE
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; DATENSATZAUFBAU: 7+3+360+360+360=1.090BYTES									
; BYTE-00=TAG																	
; BYTE-001=MONAT																
; BYTE-02=JAHR																	
; BYTE-03=WOCHENTAG																
; BYTE-04=hh																	
; BYTE-05=mm																	
; BYTE-06=ss																	
; BYTE-07=DUMMY																	
; BYTE-08=DUMMY																	
; BYTE-09=DUMMY																	
; BYTE-xxx=X-DATEN (360BYTES)													
; BYTE-xxx=Y-DATEN (360BYTES)													
; BYTE-xxx=Z-DATEN (360BYTES)													
TWI_EEPROM_DIAGRAMM_SAVE_Z:
	; ZEITSTEMPEL							
	LDS temp1,(adr_ZEITSTEMPEL_TAG)			; TAG	
	rcall TWI_EEPROM_WRITE_Z_TEMP1
	LDS temp1,(adr_ZEITSTEMPEL_MONAT)		; MONAT	
	rcall TWI_EEPROM_WRITE_Z_TEMP1
	LDS temp1,(adr_ZEITSTEMPEL_JAHR)		; JAHR	
	rcall TWI_EEPROM_WRITE_Z_TEMP1
	LDS temp1,(adr_ZEITSTEMPEL_WOCHENTAG)	; Wochentag		
	rcall TWI_EEPROM_WRITE_Z_TEMP1
	LDS temp1,(adr_ZEITSTEMPEL_hh)			; hh	
	rcall TWI_EEPROM_WRITE_Z_TEMP1
	LDS temp1,(adr_ZEITSTEMPEL_mm)			; mm	
	rcall TWI_EEPROM_WRITE_Z_TEMP1
	LDS temp1,(adr_ZEITSTEMPEL_ss)			; ss	
	rcall TWI_EEPROM_WRITE_Z_TEMP1
	clr temp1								; DUMMY	
	rcall TWI_EEPROM_WRITE_Z_TEMP1
	clr temp1								; DUMMY	
	rcall TWI_EEPROM_WRITE_Z_TEMP1
	clr temp1								; DUMMY	
	rcall TWI_EEPROM_WRITE_Z_TEMP1
;-------------------------------------------------------------------------------
; X-DATEN																		
	call ASCII_X
	ldi XL,LOW (adr_DATA_X_360)				; X-DATENFELD	
	ldi XH,HIGH(adr_DATA_X_360)
	ldi YL,LOW (360)						; SCHLEIFE		
	ldi YH,HIGH(360)
TWI_EEPROM_DIAGRAMM_SAVE_SX:
	LD temp1,X+
	rcall TWI_EEPROM_WRITE_Z_TEMP1
	sbiw YL,1								; SCHLEIFE-1	
	tst YL
	brne TWI_EEPROM_DIAGRAMM_SAVE_SX
	tst YH
	brne TWI_EEPROM_DIAGRAMM_SAVE_SX
;-------------------------------------------------------------------------------
; Y-DATEN																		
	call ASCII_Y
	ldi XL,LOW (adr_DATA_Y_360)				; X-DATENFELD	
	ldi XH,HIGH(adr_DATA_Y_360)
	ldi YL,LOW (360)						; SCHLEIFE		
	ldi YH,HIGH(360)
TWI_EEPROM_DIAGRAMM_SAVE_SY:
	LD temp1,X+
	rcall TWI_EEPROM_WRITE_Z_TEMP1
	sbiw YL,1								; SCHLEIFE-1	
	tst YL
	brne TWI_EEPROM_DIAGRAMM_SAVE_SY
	tst YH
	brne TWI_EEPROM_DIAGRAMM_SAVE_SY
;-------------------------------------------------------------------------------
; Z-DATEN																		
	call ASCII_Z
	ldi XL,LOW (adr_DATA_Z_360)				; X-DATENFELD	
	ldi XH,HIGH(adr_DATA_Z_360)
	ldi YL,LOW (360)						; SCHLEIFE		
	ldi YH,HIGH(360)
TWI_EEPROM_DIAGRAMM_SAVE_SZ:
	LD temp1,X+
	rcall TWI_EEPROM_WRITE_Z_TEMP1
	sbiw YL,1								; SCHLEIFE-1	
	tst YL
	brne TWI_EEPROM_DIAGRAMM_SAVE_SZ
	tst YH
	brne TWI_EEPROM_DIAGRAMM_SAVE_SZ
;-------------------------------------------------------------------------------
	; STOPP				
	call TWI_STOP
	call WAIT_10ms
	; ERROR				
	tst TWI_FEHLER_CODE
	brne TWI_EEPROM_DIAGRAMM_SAVE_ERROR
	call ASCII_SPACE
	call ASCII_O
	call ASCII_K
	call WAIT_1s
	ret
;-------------------------------------------------------------------------------
TWI_EEPROM_DIAGRAMM_SAVE_ERROR:
	call ASCII_E
	call ASCII_R
	call ASCII_R
	call ASCII_O
	call ASCII_R
	call WAIT_1s
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 1 BYTE WRITE und Z+1															
TWI_EEPROM_WRITE_Z_TEMP1:
	PUSH temp1	; sichern			
	; TWI-ADRESSE		
	ldi temp1,(EEPROM_ADRESSE_A)
	call TWI_MASTER_TRANSMITTER_START_TEMP1
	; EEPROM-ADRESSE	
	MOV temp1,ZH
	call TWI_MASTER_TRANSMITTER_DATA_TEMP1	; HIGH	
	MOV temp1,ZL
	call TWI_MASTER_TRANSMITTER_DATA_TEMP1	; LOW	
	; DATA				
	POP temp1	; wieder herstellen	
	call TWI_MASTER_TRANSMITTER_DATA_TEMP1	
	; Z+1				
	adiw ZL,1
	;STOP				
	call TWI_STOP
	call TWI_EEPROM_WAIT
	; ERROR	?			
	tst TWI_FEHLER_CODE
	brne TWI_EEPROM_WRITE_Z_TEMP1_ERROR
	ret
;-------------------------------------------------------------------------------
TWI_EEPROM_WRITE_Z_TEMP1_ERROR:
	call ASCII_E
	call ASCII_R
	call ASCII_R
	call ASCII_O
	call ASCII_R
	call WAIT_10ms
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 1 BYTE READ																	
TWI_EEPROM_READ_Z_TEMP1:
	; MT-TWI-ADRESSE		
	ldi temp1,(EEPROM_ADRESSE_A)
	call TWI_MASTER_TRANSMITTER_START_TEMP1
	; EEPROM-ADRESSE		
	mov temp1,ZH
	call TWI_MASTER_TRANSMITTER_DATA_TEMP1	; HIGH
	mov temp1,ZL
	call TWI_MASTER_TRANSMITTER_DATA_TEMP1	; LOW
	; MR-TWI-ADRESSE		
	ldi temp1,(EEPROM_ADRESSE_A)
	call TWI_MASTER_RECEIVER_START_TEMP1
	call TWI_MASTER_RECEIVER_DATA_LAST_BYTE_TEMP1; last BYTE (DUMMY)
	call TWI_STOP
	call WAIT_1ms
	; ERROR	?			
	tst TWI_FEHLER_CODE
	brne TWI_EEPROM_READ_Z_TEMP1_ERROR
	ret
;-------------------------------------------------------------------------------
TWI_EEPROM_READ_Z_TEMP1_ERROR:
	call ASCII_E
	call ASCII_R
	call ASCII_R
	call ASCII_O
	call ASCII_R
	call WAIT_1s
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TWI_EEPROM_DIAGRAMM_LOAD_Z:
	; MT-TWI-ADRESSE		
	ldi temp1,(EEPROM_ADRESSE_A)
	call TWI_MASTER_TRANSMITTER_START_TEMP1
	; EEPROM-ADRESSE		
	mov temp1,ZH
	call TWI_MASTER_TRANSMITTER_DATA_TEMP1	; HIGH
	mov temp1,ZL
	call TWI_MASTER_TRANSMITTER_DATA_TEMP1	; LOW
	; MR-TWI-ADRESSE		
	ldi temp1,(EEPROM_ADRESSE_A)
	call TWI_MASTER_RECEIVER_START_TEMP1
;-------------------------------------------------------------------------------
	; ZEITSTEMPEL			
	rcall TWI_MASTER_RECEIVER_DATA_TEMP1
	STS(adr_ZEITSTEMPEL_TAG),temp1			; TAG		
	rcall TWI_MASTER_RECEIVER_DATA_TEMP1
	STS(adr_ZEITSTEMPEL_MONAT),temp1		; MONAT		
	rcall TWI_MASTER_RECEIVER_DATA_TEMP1
	STS(adr_ZEITSTEMPEL_JAHR),temp1			; JAHR		
	rcall TWI_MASTER_RECEIVER_DATA_TEMP1
	STS(adr_ZEITSTEMPEL_WOCHENTAG),temp1	; Wochentag	
	rcall TWI_MASTER_RECEIVER_DATA_TEMP1
	STS(adr_ZEITSTEMPEL_hh),temp1			; hh		
	rcall TWI_MASTER_RECEIVER_DATA_TEMP1
	STS(adr_ZEITSTEMPEL_mm),temp1			; mm		
	rcall TWI_MASTER_RECEIVER_DATA_TEMP1
	STS(adr_ZEITSTEMPEL_ss),temp1			; ss		
	rcall TWI_MASTER_RECEIVER_DATA_TEMP1	; DUMMY		
	rcall TWI_MASTER_RECEIVER_DATA_TEMP1	; DUMMY		
	rcall TWI_MASTER_RECEIVER_DATA_TEMP1	; DUMMY		
;-------------------------------------------------------------------------------
	ldi ZL,LOW (adr_DATA_X_360)	; X-DATENFELD	
	ldi ZH,HIGH(adr_DATA_X_360)
	ldi XL,LOW (360)			; SCHLEIFE		
	ldi XH,HIGH(360)
TWI_EEPROM_DIAGRAMM_LOAD_Z_s1:
	rcall TWI_MASTER_RECEIVER_DATA_TEMP1
	ST Z+,temp1
	sbiw XL,1
	tst XL
	brne TWI_EEPROM_DIAGRAMM_LOAD_Z_s1
	tst XH
	brne TWI_EEPROM_DIAGRAMM_LOAD_Z_s1
;-------------------------------------------------------------------------------
	ldi ZL,LOW (adr_DATA_Y_360)	; Y-DATENFELD	
	ldi ZH,HIGH(adr_DATA_Y_360)
	ldi XL,LOW (360)			; SCHLEIFE		
	ldi XH,HIGH(360)
TWI_EEPROM_DIAGRAMM_LOAD_Z_s2:
	rcall TWI_MASTER_RECEIVER_DATA_TEMP1
	ST Z+,temp1
	sbiw XL,1
	tst XL
	brne TWI_EEPROM_DIAGRAMM_LOAD_Z_s2
	tst XH
	brne TWI_EEPROM_DIAGRAMM_LOAD_Z_s2
;-------------------------------------------------------------------------------
	ldi ZL,LOW (adr_DATA_Z_360)	; Z-DATENFELD	
	ldi ZH,HIGH(adr_DATA_Z_360)
	ldi XL,LOW (360)			; SCHLEIFE		
	ldi XH,HIGH(360)
TWI_EEPROM_DIAGRAMM_LOAD_Z_s3:
	rcall TWI_MASTER_RECEIVER_DATA_TEMP1
	ST Z+,temp1
	sbiw XL,1
	tst XL
	brne TWI_EEPROM_DIAGRAMM_LOAD_Z_s3
	tst XH
	brne TWI_EEPROM_DIAGRAMM_LOAD_Z_s3
;-------------------------------------------------------------------------------
	call TWI_MASTER_RECEIVER_DATA_LAST_BYTE_TEMP1; last BYTE (DUMMY)
	call TWI_STOP
	call TWI_EEPROM_WAIT
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TWI_EEPROM_WAIT:
	call WAIT_1ms
	; MT-TWI-ADRESSE		
	ldi temp1,(EEPROM_ADRESSE_A)
	call TWI_MASTER_TRANSMITTER_START_TEMP1
	; ERROR ?				
	tst TWI_FEHLER_CODE
	brne TWI_EEPROM_WAIT
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TWI_EEPROM_CLEAR:
	call GRAFIC_CLEAR
	call ASCII_E
	call ASCII_E
	call ASCII_P
	call ASCII_R
	call ASCII_O
	call ASCII_M
	call ASCII_SPACE
	call ASCII_C
	call ASCII_L
	call ASCII_E
	call ASCII_A
	call ASCII_R
	call ASCII_SPACE
	call ASCII_PUNKT3
	call ASCII_CURSOR_ZEILE_3
;-------------------------------------------------------------------------------
	; START-ADRESSE (muss immer ein Vielfaches von 128 sein)					
	clr ZL
	clr ZH
	ldi XL,LOW (512) 	; SCHLEIFE	
	ldi XH,HIGH(512)
TWI_EEPROM_CLEAR_s:
	call TWI_EEPROM_CLEAR_PAGE
	sbiw XL,1		 	; SCHLEIFE-1
	tst XL
	brne TWI_EEPROM_CLEAR_s
	tst XH
	brne TWI_EEPROM_CLEAR_s
	sbiw ZL,1			;-1			
	call TWI_EEPROM_CLEAR_ANZEIGE_Z
	; ERROR ?				
	tst TWI_FEHLER_CODE
	breq TWI_EEPROM_CLEAR_OK
	call WAIT_1s
	call WAIT_1s
	ret
;-------------------------------------------------------------------------------
TWI_EEPROM_CLEAR_OK:
	; OK				
	call ASCII_SPACE2
	call ASCII_O
	call ASCII_K
	call WAIT_1s
	call TWI_EEPROM_CLEAR_CHECK
ret
;-------------------------------------------------------------------------------
TWI_EEPROM_CLEAR_PAGE:
	; MT-TWI-ADRESSE		
	ldi temp1,(EEPROM_ADRESSE_A)
	call TWI_MASTER_TRANSMITTER_START_TEMP1
	; EEPROM-ADRESSE		
	mov temp1,ZH	
	call TWI_MASTER_TRANSMITTER_DATA_TEMP1	; HIGH	
	mov temp1,ZL	
	call TWI_MASTER_TRANSMITTER_DATA_TEMP1	; LOW	
	; SCHLEIFE				
	ldi temp9,128
TWI_EEPROM_CLEAR_PAGE_s:
	ldi temp1,0
	call TWI_MASTER_TRANSMITTER_DATA_TEMP1	; DATA	
	adiw ZL,1								; Z+1	
	; ERROR ?				
	tst TWI_FEHLER_CODE
	brne TWI_EEPROM_CLEAR_ERROR
	; SCHLEIFE				
	dec temp9
	brne TWI_EEPROM_CLEAR_PAGE_s
	; STOPP					
	call TWI_STOP
	; ANZEIGE				
	call TWI_EEPROM_CLEAR_ANZEIGE_Z
	; WAIT					
	call TWI_EEPROM_WAIT
ret
;-------------------------------------------------------------------------------
TWI_EEPROM_CLEAR_ANZEIGE_Z:
	push XL
	push XH
	push ZL
	push ZH
	call ASCII_CURSOR_ZEILE_3
	mov temp1,ZL	
	mov temp2,ZH
	call ANZEIGE_5_STELLEN_TEMP1_TEMP2
	pop ZH
	pop ZL
	pop XH
	pop XL
ret
;-------------------------------------------------------------------------------
TWI_EEPROM_CLEAR_ERROR:
	call ASCII_SPACE
	call ASCII_E
	call ASCII_R
	call ASCII_R
	call ASCII_O
	call ASCII_R
	call WAIT_1s
ret
;-------------------------------------------------------------------------------
TWI_EEPROM_CLEAR_CHECK:
	; CHECK				
	call GRAFIC_CLEAR
	call ASCII_E
	call ASCII_E
	call ASCII_P
	call ASCII_R
	call ASCII_O
	call ASCII_M
	call ASCII_SPACE
	call ASCII_R
	call ASCII_E
	call ASCII_A
	call ASCII_D
	call ASCII_SPACE
	call ASCII_PUNKT3
	call ASCII_CURSOR_ZEILE_3
	; MT-TWI-ADRESSE		
	ldi temp1,(EEPROM_ADRESSE_A)
	call TWI_MASTER_TRANSMITTER_START_TEMP1
	; EEPROM-ADRESSE		
	clr ZL
	clr ZH
	mov temp1,ZH
	call TWI_MASTER_TRANSMITTER_DATA_TEMP1	; HIGH
	mov temp1,ZL
	call TWI_MASTER_TRANSMITTER_DATA_TEMP1	; LOW
	; MR-TWI-ADRESSE		
	ldi temp1,(EEPROM_ADRESSE_A)
	call TWI_MASTER_RECEIVER_START_TEMP1
TWI_EEPROM_CLEAR_CHECK_s:
	; ANZEIGE				
	tst ZL
	brne TWI_EEPROM_CLEAR_CHECK_w
	call TWI_EEPROM_CLEAR_ANZEIGE_Z
TWI_EEPROM_CLEAR_CHECK_w:
	; DATA read				
	call TWI_MASTER_RECEIVER_DATA_TEMP1
	; ERROR ?				
	tst TWI_FEHLER_CODE
	brne TWI_EEPROM_CLEAR_CHECK_ERROR
	; ERROR	?				
	tst temp1
	brne TWI_EEPROM_CLEAR_CHECK_ERROR
	; SCHLEIFE				
	adiw ZL,1
	tst ZL
	brne TWI_EEPROM_CLEAR_CHECK_s
	tst ZH
	brne TWI_EEPROM_CLEAR_CHECK_s
	call TWI_MASTER_RECEIVER_DATA_LAST_BYTE_TEMP1; last BYTE (DUMMY)
	; ANZEIGE				
	sbiw ZL,1
	call TWI_EEPROM_CLEAR_ANZEIGE_Z
	call TWI_STOP
	call ASCII_SPACE
	call ASCII_O
	call ASCII_K
	call WAIT_1s
	ret
TWI_EEPROM_CLEAR_CHECK_ERROR:
	call TWI_MASTER_RECEIVER_DATA_LAST_BYTE_TEMP1; last BYTE (DUMMY)
	call TWI_STOP
	call TWI_EEPROM_CLEAR_ANZEIGE_Z
	call ASCII_SPACE
	call ASCII_E
	call ASCII_R
	call ASCII_R
	call ASCII_O
	call ASCII_R
	call WAIT_1s
	call WAIT_1s
	call WAIT_1s
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################

