; ##############################################################################
; ##############################################################################
; ##############################################################################
; REGISTER 14h																	
; 000----- => Reserviert														
; ---00--- => RANGE +/- 2g														
; ---01--- => RANGE +/- 4g														
; ---10--- => RANGE +/- 8g														
; -----000 => BANDWITH 25Hz														
; -----001 => BANDWITH 50Hz														
; -----010 => BANDWITH 100Hz													
; -----011 => BANDWITH 190Hz													
; -----100 => BANDWITH 375Hz													
; -----101 => BANDWITH 750Hz													
; -----110 => BANDWITH 1500Hz													
;																				
; REGISTER 15h																	
; 1------- => SPI4			
; -1------ => enable_adv_INT
; --1----- => new_DATA_INT	
; ---1---- => latch_INT		
; ----1--- => shadow_dis	
; -----11- => wake_up_pause	
; -------1 => wake_up		
;																				
BMA020_INITIALISIERUNG:
	; REGISTER 14h							
	ldi temp1,(0x14)						; Register-ADRESSE	
	rcall BMA020_REGISTER_READ_TEMP1		; READ				
	andi temp1,0b11100000					; reservierte Bits beibehalten	
	ori  temp1,0b00000000					; RANGE +/- 2g, BANDWITH 25Hz	
;	ori  temp1,0b00000001					; RANGE +/- 2g, BANDWITH 50Hz	
;	ori  temp1,0b00000110					; RANGE +/- 2g, BANDWITH 1500Hz	
	mov temp2,temp1							; Register-INHALT	
	ldi temp1,(0x14)						; Register-ADRESSE	
	rcall BMA020_REGISTER_WRITE_TEMP1_TEMP2	; WRITE				
	; REGISTER 15h							
	ldi temp1,(0x15)						; Register-ADRESSE	
	rcall BMA020_REGISTER_READ_TEMP1		; READ				
	ori  temp1,0b00000000					; 0b00100000 new_DATA_INT		
	mov temp2,temp1							; Register-INHALT	
	ldi temp1,(0x15)						; Register-ADRESSE	
	rcall BMA020_REGISTER_WRITE_TEMP1_TEMP2	; WRITE				
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
BMA020_CHECK:
	ldi temp1,(BMA020_ADRESSE)
	rcall TWI_MASTER_TRANSMITTER_START_TEMP1
	rcall TWI_STOP
	tst TWI_FEHLER_CODE
	brne BMA020_CHECK_ERROR
	ret
;-------------------------------------------------------------------------------
BMA020_CHECK_ERROR:
	call GRAFIC_CLEAR
	call ASCII_B
	call ASCII_M
	call ASCII_A
	call ASCII_0
	call ASCII_2
	call ASCII_0
	call ASCII_SPACE
	call ANZEIGE_TEXT_NOT_FOUND_KURZ
	call WAIT_1s
	call WAIT_1s
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Registerinhalt eines Registers auslesen										
; INP: temp1 (Register-ADRESSE)													
; OUT: temp1 (Register-INHALT)													
BMA020_REGISTER_READ_TEMP1:
	push temp1									; Register-ADRESSE	
	ldi temp1,(BMA020_ADRESSE)					; I2C-ADRESSE		
	rcall TWI_MASTER_TRANSMITTER_START_TEMP1	; START-MT			
	pop temp1									; Register-ADRESSE	
	rcall TWI_MASTER_TRANSMITTER_DATA_TEMP1		; BYTE-WRITE		
	ldi temp1,(BMA020_ADRESSE)					; I2C-ADRESSE		
	rcall TWI_MASTER_RECEIVER_START_TEMP1		; START-MR			
	rcall TWI_MASTER_RECEIVER_DATA_LAST_BYTE_TEMP1	; LAST BYTE read	
	rjmp TWI_STOP								; STOP				
; ##############################################################################
; ##############################################################################
; ##############################################################################
; INP: temp1 (Register-ADRESSE)													
; INP: temp2 (Register-INHALT)													
BMA020_REGISTER_WRITE_TEMP1_TEMP2:
	push temp1									; Register-ADRESSE	
	ldi temp1,(BMA020_ADRESSE)					; I2C-ADRESSE		
	rcall TWI_MASTER_TRANSMITTER_START_TEMP1	; START-MT			
	pop temp1									; Register-ADRESSE	
	rcall TWI_MASTER_TRANSMITTER_DATA_TEMP1		; BYTE-WRITE		
	mov temp1,temp2
	rcall TWI_MASTER_TRANSMITTER_DATA_TEMP1		; BYTE-WRITE		
	rjmp TWI_STOP								; STOP				
; ##############################################################################
; ##############################################################################
; ##############################################################################
BMA020_OFFSET_SCHNELL:
	; OFFSET NULL		
	STS(adr_BMA020_X_OFFSET_L),NULL
	STS(adr_BMA020_X_OFFSET_H),NULL
	STS(adr_BMA020_Y_OFFSET_L),NULL
	STS(adr_BMA020_Y_OFFSET_H),NULL
	STS(adr_BMA020_Z_OFFSET_L),NULL
	STS(adr_BMA020_Z_OFFSET_H),NULL
	; MESSUNG			
	call BMA020_MESSUNG
	; OFFSET X			
	LDS temp1,(adr_BMA020_X_L)
	LDS temp2,(adr_BMA020_X_H)
	STS(adr_BMA020_X_OFFSET_L),temp1
	STS(adr_BMA020_X_OFFSET_H),temp2
	; OFFSET Y			
	LDS temp1,(adr_BMA020_Y_L)
	LDS temp2,(adr_BMA020_Y_H)
	STS(adr_BMA020_Y_OFFSET_L),temp1
	STS(adr_BMA020_Y_OFFSET_H),temp2
	; OFFSET Z			
	LDS temp1,(adr_BMA020_Z_L)
	LDS temp2,(adr_BMA020_Z_H)
	STS(adr_BMA020_Z_OFFSET_L),temp1
	STS(adr_BMA020_Z_OFFSET_H),temp2
	; DUMMY				
	call BMA020_MESSUNG
	call BMA020_MESSUNG
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
BMA020_OFFSET_AUTOMATIK:
	LDS temp,(adr_FREIGABE_BMA020_AUTO_OFFSET)	; AUTO-OFFSET
	tst temp
	brne BMA020_OFFSET_AUTOMATIK_w1
	ret
BMA020_OFFSET_AUTOMATIK_w1:
	STS(adr_FREIGABE_BMA020_AUTO_OFFSET),NULL	; AUTO-OFFSET
	rcall BMA020_OFFSET_AUTOMATIK_X
	rcall BMA020_OFFSET_AUTOMATIK_Y
	rcall BMA020_OFFSET_AUTOMATIK_Z
ret
;-------------------------------------------------------------------------------
BMA020_OFFSET_AUTOMATIK_X:
	LDS temp1,(adr_BMA020_X_L)
	LDS temp2,(adr_BMA020_X_H)
	tst temp1
	brne BMA020_OFFSET_AUTOMATIK_X1
	tst temp2
	brne BMA020_OFFSET_AUTOMATIK_X1
	ret
BMA020_OFFSET_AUTOMATIK_X1:
	tst temp2
	brmi BMA020_OFFSET_AUTOMATIK_X1M
	LDS temp1,(adr_BMA020_X_OFFSET_L)
	LDS temp2,(adr_BMA020_X_OFFSET_H)
	add temp1,EINS
	adc temp2,NULL
	STS(adr_BMA020_X_OFFSET_L),temp1
	STS(adr_BMA020_X_OFFSET_H),temp2
	ret
BMA020_OFFSET_AUTOMATIK_X1M:
	LDS temp1,(adr_BMA020_X_OFFSET_L)
	LDS temp2,(adr_BMA020_X_OFFSET_H)
	sub temp1,EINS
	sbc temp2,NULL
	STS(adr_BMA020_X_OFFSET_L),temp1
	STS(adr_BMA020_X_OFFSET_H),temp2
ret
;-------------------------------------------------------------------------------
BMA020_OFFSET_AUTOMATIK_Y:
	LDS temp1,(adr_BMA020_Y_L)
	LDS temp2,(adr_BMA020_Y_H)
	tst temp1
	brne BMA020_OFFSET_AUTOMATIK_Y1
	tst temp2
	brne BMA020_OFFSET_AUTOMATIK_Y1
	ret
BMA020_OFFSET_AUTOMATIK_Y1:
	tst temp2
	brmi BMA020_OFFSET_AUTOMATIK_Y1M
	LDS temp1,(adr_BMA020_Y_OFFSET_L)
	LDS temp2,(adr_BMA020_Y_OFFSET_H)
	add temp1,EINS
	adc temp2,NULL
	STS(adr_BMA020_Y_OFFSET_L),temp1
	STS(adr_BMA020_Y_OFFSET_H),temp2
	ret
BMA020_OFFSET_AUTOMATIK_Y1M:
	LDS temp1,(adr_BMA020_Y_OFFSET_L)
	LDS temp2,(adr_BMA020_Y_OFFSET_H)
	sub temp1,EINS
	sbc temp2,NULL
	STS(adr_BMA020_Y_OFFSET_L),temp1
	STS(adr_BMA020_Y_OFFSET_H),temp2
ret
;-------------------------------------------------------------------------------
BMA020_OFFSET_AUTOMATIK_Z:
	LDS temp1,(adr_BMA020_Z_L)
	LDS temp2,(adr_BMA020_Z_H)
	tst temp1
	brne BMA020_OFFSET_AUTOMATIK_Z1
	tst temp2
	brne BMA020_OFFSET_AUTOMATIK_Z1
	ret
BMA020_OFFSET_AUTOMATIK_Z1:
	tst temp2
	brmi BMA020_OFFSET_AUTOMATIK_Z1M
	LDS temp1,(adr_BMA020_Z_OFFSET_L)
	LDS temp2,(adr_BMA020_Z_OFFSET_H)
	add temp1,EINS
	adc temp2,NULL
	STS(adr_BMA020_Z_OFFSET_L),temp1
	STS(adr_BMA020_Z_OFFSET_H),temp2
	ret
BMA020_OFFSET_AUTOMATIK_Z1M:
	LDS temp1,(adr_BMA020_Z_OFFSET_L)
	LDS temp2,(adr_BMA020_Z_OFFSET_H)
	sub temp1,EINS
	sbc temp2,NULL
	STS(adr_BMA020_Z_OFFSET_L),temp1
	STS(adr_BMA020_Z_OFFSET_H),temp2
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
BMA020_MESSUNG:
	; Messung initialisieren	
	ldi temp1,(BMA020_ADRESSE)					; I2C-ADRESSE		
	rcall TWI_MASTER_TRANSMITTER_START_TEMP1	; START-MT			
	; ERROR						
	tst TWI_FEHLER_CODE
	brne BMA020_MESSUNG_ERROR_TWI
	ldi temp1,(0x02)							; Register-ADRESSE	
	rcall TWI_MASTER_TRANSMITTER_DATA_TEMP1		; BYTE-WRITE		
	; ERROR						
	tst TWI_FEHLER_CODE
	brne BMA020_MESSUNG_ERROR_TWI
	; 6 Bytes auslesen			
	ldi temp1,(BMA020_ADRESSE)					; I2C-ADRESSE		
	rcall TWI_MASTER_RECEIVER_START_TEMP1		; START-MR			
	rcall TWI_MASTER_RECEIVER_DATA_TEMP1		; BYTE read			
	STS(adr_BMA020_X_L),temp1
	rcall TWI_MASTER_RECEIVER_DATA_TEMP1		; BYTE read			
	STS(adr_BMA020_X_H),temp1

	rcall TWI_MASTER_RECEIVER_DATA_TEMP1		; BYTE read			
	STS(adr_BMA020_Y_L),temp1
	rcall TWI_MASTER_RECEIVER_DATA_TEMP1		; BYTE read			
	STS(adr_BMA020_Y_H),temp1

	rcall TWI_MASTER_RECEIVER_DATA_TEMP1		; BYTE read			
	STS(adr_BMA020_Z_L),temp1
	call TWI_MASTER_RECEIVER_DATA_LAST_BYTE_TEMP1	; LAST BYTE read	
	STS(adr_BMA020_Z_H),temp1
;	rcall TWI_STOP								; STOP				
	; ERROR						
	tst TWI_FEHLER_CODE
	brne BMA020_MESSUNG_ERROR_TWI
	; ERROR (MESSWERTE)			
	LDS temp,(adr_BMA020_X_L)
	sbrs temp,0					; Skip if...
	rjmp BMA020_MESSUNG_ERROR
	LDS temp,(adr_BMA020_Y_L)
	sbrs temp,0					; Skip if...
	rjmp BMA020_MESSUNG_ERROR
	LDS temp,(adr_BMA020_Z_L)
	sbrs temp,0					; Skip if...
	rjmp BMA020_MESSUNG_ERROR
	; BERECHNUNG				
	rjmp BMA020_BERECHNUNG
;-------------------------------------------------------------------------------
BMA020_MESSUNG_ERROR:
	ldi temp,(BMA020_ERROR_MESSUNG)
;-------------------------------------------------------------------------------
BMA020_MESSUNG_ERROR_TWI:
	rcall TWI_STOP	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; BITs 6xrechts (signiert)														
BMA020_BERECHNUNG:
	; "X" BITs 6xrechts (signiert)	
	LDS temp1,(adr_BMA020_X_L)
	LDS temp2,(adr_BMA020_X_H)
	rcall BMA020_BITS_6xRECHTS_TEMP1_TEMP2	; 10Bit Wert
	; Offset subtrahieren			
	LDS temp3,(adr_BMA020_X_OFFSET_L)
	LDS temp4,(adr_BMA020_X_OFFSET_H)
	sub temp1,temp3
	sbc temp2,temp4
	; im SRAM ablegen				
	STS(adr_BMA020_X_L),temp1
	STS(adr_BMA020_X_H),temp2
	; Umwandlung auf 8-Bit			
	rcall BMA020_16_8_TEMP1_TEMP2
	STS(adr_BMA020_X),temp1
;-------------------------------------------------------------------------------
	; "Y" BITs 6xrechts (signiert)	
	LDS temp1,(adr_BMA020_Y_L)
	LDS temp2,(adr_BMA020_Y_H)
	rcall BMA020_BITS_6xRECHTS_TEMP1_TEMP2	; 10Bit Wert
	; Offset subtrahieren			
	LDS temp3,(adr_BMA020_Y_OFFSET_L)
	LDS temp4,(adr_BMA020_Y_OFFSET_H)
	sub temp1,temp3
	sbc temp2,temp4
	; im SRAM ablegen				
	STS(adr_BMA020_Y_L),temp1
	STS(adr_BMA020_Y_H),temp2
	; Umwandlung auf 8-Bit			
	rcall BMA020_16_8_TEMP1_TEMP2
	STS(adr_BMA020_Y),temp1
;-------------------------------------------------------------------------------
	; "Z" BITs 6xrechts (signiert)	
	LDS temp1,(adr_BMA020_Z_L)
	LDS temp2,(adr_BMA020_Z_H)
	rcall BMA020_BITS_6xRECHTS_TEMP1_TEMP2	; 10Bit Wert
	; Offset subtrahieren			
	LDS temp3,(adr_BMA020_Z_OFFSET_L)
	LDS temp4,(adr_BMA020_Z_OFFSET_H)
	sub temp1,temp3
	sbc temp2,temp4
	; im SRAM ablegen				
	STS(adr_BMA020_Z_L),temp1
	STS(adr_BMA020_Z_H),temp2
	; Umwandlung auf 8-Bit			
	rcall BMA020_16_8_TEMP1_TEMP2
	STS(adr_BMA020_Z),temp1
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
BMA020_BITS_6xRECHTS_TEMP1_TEMP2:
	ASR temp2	; 1x arithmetisch rechts (Vorzeichen bleibt) (1) 
	ROR temp1	; 1x rechts ber CARYY							 
	ASR temp2	; 1x arithmetisch rechts (Vorzeichen bleibt) (2) 
	ROR temp1	; 1x rechts ber CARYY							 
	ASR temp2	; 1x arithmetisch rechts (Vorzeichen bleibt) (3) 
	ROR temp1	; 1x rechts ber CARYY							 
	ASR temp2	; 1x arithmetisch rechts (Vorzeichen bleibt) (4) 
	ROR temp1	; 1x rechts ber CARYY							 
	ASR temp2	; 1x arithmetisch rechts (Vorzeichen bleibt) (5) 
	ROR temp1	; 1x rechts ber CARYY							 
	ASR temp2	; 1x arithmetisch rechts (Vorzeichen bleibt) (6) 
	ROR temp1	; 1x rechts ber CARYY							 
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; -128...+127																	
BMA020_16_8_TEMP1_TEMP2:
	; NEGATIV ?			
	tst temp2
	brmi BMA020_16_8_TEMP1_TEMP2_N
BMA020_16_8_TEMP1_TEMP2_P:
	; berlauf (HIGH)	
	tst temp2
	brne BMA020_16_8_TEMP1_TEMP2_P_ERROR
	; berlauf (LOW)	
	cpi temp1,127+1
	brsh BMA020_16_8_TEMP1_TEMP2_P_ERROR
	ret
BMA020_16_8_TEMP1_TEMP2_P_ERROR:
	; begrenzen			
	ldi temp1,127
	ret
;-------------------------------------------------------------------------------
BMA020_16_8_TEMP1_TEMP2_N:
	; BERLAUF (HIGH)
	cpi temp2,255
	brne BMA020_16_8_TEMP1_TEMP2_N_ERROR
	ret
BMA020_16_8_TEMP1_TEMP2_N_ERROR:
	ldi temp1,LOW(-128)
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################

